from typing import List, Optional, Dict, Iterable
import aspose.pycore
import aspose.pydrawing
import aspose.psd
import aspose.psd.asynctask
import aspose.psd.brushes
import aspose.psd.coreexceptions
import aspose.psd.coreexceptions.compressors
import aspose.psd.coreexceptions.imageformats
import aspose.psd.customfonthandler
import aspose.psd.dithering
import aspose.psd.evalute
import aspose.psd.exif
import aspose.psd.exif.enums
import aspose.psd.extensions
import aspose.psd.fileformats
import aspose.psd.fileformats.ai
import aspose.psd.fileformats.bmp
import aspose.psd.fileformats.core
import aspose.psd.fileformats.core.blending
import aspose.psd.fileformats.core.vectorpaths
import aspose.psd.fileformats.jpeg
import aspose.psd.fileformats.jpeg2000
import aspose.psd.fileformats.pdf
import aspose.psd.fileformats.png
import aspose.psd.fileformats.psd
import aspose.psd.fileformats.psd.core
import aspose.psd.fileformats.psd.core.rawcolor
import aspose.psd.fileformats.psd.layers
import aspose.psd.fileformats.psd.layers.adjustmentlayers
import aspose.psd.fileformats.psd.layers.animation
import aspose.psd.fileformats.psd.layers.filllayers
import aspose.psd.fileformats.psd.layers.fillsettings
import aspose.psd.fileformats.psd.layers.gradient
import aspose.psd.fileformats.psd.layers.layereffects
import aspose.psd.fileformats.psd.layers.layerresources
import aspose.psd.fileformats.psd.layers.layerresources.lfx2resources
import aspose.psd.fileformats.psd.layers.layerresources.strokeresources
import aspose.psd.fileformats.psd.layers.layerresources.typetoolinfostructures
import aspose.psd.fileformats.psd.layers.smartfilters
import aspose.psd.fileformats.psd.layers.smartfilters.rendering
import aspose.psd.fileformats.psd.layers.smartobjects
import aspose.psd.fileformats.psd.layers.text
import aspose.psd.fileformats.psd.resources
import aspose.psd.fileformats.psd.resources.enums
import aspose.psd.fileformats.psd.resources.resolutionenums
import aspose.psd.fileformats.tiff
import aspose.psd.fileformats.tiff.enums
import aspose.psd.fileformats.tiff.filemanagement
import aspose.psd.flatarray
import aspose.psd.flatarray.exceptions
import aspose.psd.imagefilters
import aspose.psd.imagefilters.filteroptions
import aspose.psd.imageloadoptions
import aspose.psd.imageoptions
import aspose.psd.interfaces
import aspose.psd.memorymanagement
import aspose.psd.multithreading
import aspose.psd.palettehelper
import aspose.psd.progressmanagement
import aspose.psd.shapes
import aspose.psd.shapesegments
import aspose.psd.sources
import aspose.psd.xmp
import aspose.psd.xmp.schemas
import aspose.psd.xmp.schemas.dublincore
import aspose.psd.xmp.schemas.pdf
import aspose.psd.xmp.schemas.photoshop
import aspose.psd.xmp.schemas.xmpbaseschema
import aspose.psd.xmp.schemas.xmpdm
import aspose.psd.xmp.schemas.xmpmm
import aspose.psd.xmp.schemas.xmprm
import aspose.psd.xmp.types
import aspose.psd.xmp.types.basic
import aspose.psd.xmp.types.complex
import aspose.psd.xmp.types.complex.colorant
import aspose.psd.xmp.types.complex.dimensions
import aspose.psd.xmp.types.complex.font
import aspose.psd.xmp.types.complex.resourceevent
import aspose.psd.xmp.types.complex.resourceref
import aspose.psd.xmp.types.complex.thumbnail
import aspose.psd.xmp.types.complex.version
import aspose.psd.xmp.types.derived

class AdjustmentLayerResource(aspose.psd.fileformats.psd.layers.LayerResource):
    '''Base Class for adjustments layer resources'''
    
    def save(self, stream_container : aspose.psd.StreamContainer, psd_version : int):
        '''Saves the resource to the specified stream container.
        
        :param stream_container: The stream container to save to.
        :param psd_version: The PSD version.'''
        ...
    
    @property
    def signature(self) -> int:
        '''Gets the signature.'''
        ...
    
    @property
    def key(self) -> int:
        '''Gets the layer resource key.'''
        ...
    
    @property
    def length(self) -> int:
        '''Gets the layer resource length in bytes.'''
        ...
    
    @property
    def psd_version(self) -> int:
        ...
    
    @classmethod
    @property
    def RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @classmethod
    @property
    def PSB_RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    ...

class AnimatedDataSectionStructure(OSTypeStructure):
    '''The section with animated data.'''
    
    def save(self, stream_container : aspose.psd.StreamContainer):
        '''Saves the structure to the specified stream container.
        
        :param stream_container: The stream container.'''
        ...
    
    def save_without_key_name(self, stream_container : aspose.psd.StreamContainer):
        '''Saves the structure to the specified stream container.
        
        :param stream_container: The stream container.'''
        ...
    
    def get_header_length(self) -> int:
        '''Gets the header length.
        
        :returns: The header length'''
        ...
    
    @property
    def key(self) -> int:
        '''Gets the structure key.'''
        ...
    
    @property
    def key_name(self) -> aspose.psd.fileformats.psd.layers.layerresources.ClassID:
        ...
    
    @key_name.setter
    def key_name(self, value : aspose.psd.fileformats.psd.layers.layerresources.ClassID):
        ...
    
    @property
    def length(self) -> int:
        '''Gets the :py:class:`aspose.psd.fileformats.psd.layers.layerresources.OSTypeStructure` length in bytes.'''
        ...
    
    @property
    def items(self) -> List[aspose.psd.fileformats.psd.layers.layerresources.OSTypeStructure]:
        '''Gets the animated data section structures.'''
        ...
    
    @classmethod
    @property
    def STRUCTURE_KEY(cls) -> int:
        ...
    
    ...

class BlncResource(AdjustmentLayerResource):
    '''BlncResource class is a resource of Color Adjustment Layer.'''
    
    def save(self, stream_container : aspose.psd.StreamContainer, psd_version : int):
        '''Saves the resource to the specified stream container.
        
        :param stream_container: The stream container to save to.
        :param psd_version: The PSD version.'''
        ...
    
    @property
    def signature(self) -> int:
        '''Gets the signature.'''
        ...
    
    @property
    def key(self) -> int:
        '''Gets the layer resource key.'''
        ...
    
    @property
    def length(self) -> int:
        '''Gets the layer resource length in bytes.'''
        ...
    
    @property
    def psd_version(self) -> int:
        ...
    
    @classmethod
    @property
    def RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @classmethod
    @property
    def PSB_RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @property
    def preserve_luminosity(self) -> bool:
        ...
    
    @preserve_luminosity.setter
    def preserve_luminosity(self, value : bool):
        ...
    
    @property
    def shadows_cyan_red_balance(self) -> int:
        ...
    
    @shadows_cyan_red_balance.setter
    def shadows_cyan_red_balance(self, value : int):
        ...
    
    @property
    def shadows_magenta_green_balance(self) -> int:
        ...
    
    @shadows_magenta_green_balance.setter
    def shadows_magenta_green_balance(self, value : int):
        ...
    
    @property
    def shadows_yellow_blue_balance(self) -> int:
        ...
    
    @shadows_yellow_blue_balance.setter
    def shadows_yellow_blue_balance(self, value : int):
        ...
    
    @property
    def midtones_cyan_red_balance(self) -> int:
        ...
    
    @midtones_cyan_red_balance.setter
    def midtones_cyan_red_balance(self, value : int):
        ...
    
    @property
    def midtones_magenta_green_balance(self) -> int:
        ...
    
    @midtones_magenta_green_balance.setter
    def midtones_magenta_green_balance(self, value : int):
        ...
    
    @property
    def midtones_yellow_blue_balance(self) -> int:
        ...
    
    @midtones_yellow_blue_balance.setter
    def midtones_yellow_blue_balance(self, value : int):
        ...
    
    @property
    def highlights_cyan_red_balance(self) -> int:
        ...
    
    @highlights_cyan_red_balance.setter
    def highlights_cyan_red_balance(self, value : int):
        ...
    
    @property
    def highlights_magenta_green_balance(self) -> int:
        ...
    
    @highlights_magenta_green_balance.setter
    def highlights_magenta_green_balance(self, value : int):
        ...
    
    @property
    def highlights_yellow_blue_balance(self) -> int:
        ...
    
    @highlights_yellow_blue_balance.setter
    def highlights_yellow_blue_balance(self, value : int):
        ...
    
    @classmethod
    @property
    def TYPE_TOOL_KEY(cls) -> int:
        ...
    
    ...

class BlwhResource(AdjustmentLayerResource):
    '''BlwhResource class is a resource of Black and White Adjustment Layer.'''
    
    def save(self, stream_container : aspose.psd.StreamContainer, psd_version : int):
        '''Saves the resource to the specified stream container.
        
        :param stream_container: The stream container to save to.
        :param psd_version: The PSD version.'''
        ...
    
    @property
    def signature(self) -> int:
        '''Gets the signature.'''
        ...
    
    @property
    def key(self) -> int:
        '''Gets the layer resource key.'''
        ...
    
    @property
    def length(self) -> int:
        '''Gets the layer resource length in bytes.'''
        ...
    
    @property
    def psd_version(self) -> int:
        ...
    
    @classmethod
    @property
    def RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @classmethod
    @property
    def PSB_RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @property
    def reds(self) -> int:
        '''Gets the reds value.'''
        ...
    
    @reds.setter
    def reds(self, value : int):
        '''Sets the reds value.'''
        ...
    
    @property
    def yellows(self) -> int:
        '''Gets the yellows value.'''
        ...
    
    @yellows.setter
    def yellows(self, value : int):
        '''Sets the yellows value.'''
        ...
    
    @property
    def greens(self) -> int:
        '''Gets the greens value.'''
        ...
    
    @greens.setter
    def greens(self, value : int):
        '''Sets the greens value.'''
        ...
    
    @property
    def cyans(self) -> int:
        '''Gets the cyans value.'''
        ...
    
    @cyans.setter
    def cyans(self, value : int):
        '''Sets the cyans value.'''
        ...
    
    @property
    def blues(self) -> int:
        '''Gets the blues value.'''
        ...
    
    @blues.setter
    def blues(self, value : int):
        '''Sets the blues value.'''
        ...
    
    @property
    def magentas(self) -> int:
        '''Gets the magentas value.'''
        ...
    
    @magentas.setter
    def magentas(self, value : int):
        '''Sets the magentas value.'''
        ...
    
    @property
    def use_tint(self) -> bool:
        ...
    
    @use_tint.setter
    def use_tint(self, value : bool):
        ...
    
    @property
    def tint_color(self) -> int:
        ...
    
    @tint_color.setter
    def tint_color(self, value : int):
        ...
    
    @property
    def bw_preset_kind(self) -> int:
        ...
    
    @bw_preset_kind.setter
    def bw_preset_kind(self, value : int):
        ...
    
    @property
    def black_and_white_preset_file_name(self) -> str:
        ...
    
    @black_and_white_preset_file_name.setter
    def black_and_white_preset_file_name(self, value : str):
        ...
    
    @classmethod
    @property
    def TYPE_TOOL_KEY(cls) -> int:
        ...
    
    ...

class BooleanResource(aspose.psd.fileformats.psd.layers.LayerResource):
    '''Class BooleanResource. It's pseudo resource. Photoshop haven't it'''
    
    def save(self, stream_container : aspose.psd.StreamContainer, psd_version : int):
        '''Saves the specified stream container.
        
        :param stream_container: The stream container.
        :param psd_version: The PSD version.'''
        ...
    
    @property
    def signature(self) -> int:
        '''Gets the signature.'''
        ...
    
    @property
    def key(self) -> int:
        '''Gets the layer resource key.'''
        ...
    
    @property
    def length(self) -> int:
        '''Gets the layer resource length in bytes.'''
        ...
    
    @property
    def psd_version(self) -> int:
        ...
    
    @classmethod
    @property
    def RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @classmethod
    @property
    def PSB_RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    ...

class BritResource(AdjustmentLayerResource):
    '''Class BritResource. Resource of Brightness/Contrast Adjustment Layer'''
    
    def save(self, stream_container : aspose.psd.StreamContainer, psd_version : int):
        '''Saves the resource to the specified stream container.
        
        :param stream_container: The stream container to save to.
        :param psd_version: The PSD version.'''
        ...
    
    @property
    def signature(self) -> int:
        '''Gets the signature.'''
        ...
    
    @property
    def key(self) -> int:
        '''Gets the layer resource key.'''
        ...
    
    @property
    def length(self) -> int:
        '''Gets the layer resource length in bytes.'''
        ...
    
    @property
    def psd_version(self) -> int:
        ...
    
    @classmethod
    @property
    def RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @classmethod
    @property
    def PSB_RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @property
    def brightness(self) -> int:
        '''Gets the brightness.'''
        ...
    
    @brightness.setter
    def brightness(self, value : int):
        '''Sets the brightness.'''
        ...
    
    @property
    def contrast(self) -> int:
        '''Gets the contrast.'''
        ...
    
    @contrast.setter
    def contrast(self, value : int):
        '''Sets the contrast.'''
        ...
    
    @property
    def mean_value_for_brightness_and_contrast(self) -> int:
        ...
    
    @mean_value_for_brightness_and_contrast.setter
    def mean_value_for_brightness_and_contrast(self, value : int):
        ...
    
    @property
    def lab_color(self) -> bool:
        ...
    
    @lab_color.setter
    def lab_color(self, value : bool):
        ...
    
    @classmethod
    @property
    def TYPE_TOOL_KEY(cls) -> int:
        ...
    
    ...

class CgEdResource(AdjustmentLayerResource):
    '''Class CgEdResource. Content Generator Extra Data (Photoshop CS5)'''
    
    def save(self, stream_container : aspose.psd.StreamContainer, psd_version : int):
        '''Saves the resource to the specified stream container.
        
        :param stream_container: The stream container to save to.
        :param psd_version: The PSD version.'''
        ...
    
    @property
    def signature(self) -> int:
        '''Gets the signature.'''
        ...
    
    @property
    def key(self) -> int:
        '''Gets the layer resource key.'''
        ...
    
    @property
    def length(self) -> int:
        '''Gets the layer resource length in bytes.'''
        ...
    
    @property
    def psd_version(self) -> int:
        ...
    
    @classmethod
    @property
    def RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @classmethod
    @property
    def PSB_RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @property
    def version(self) -> int:
        '''Gets the version.'''
        ...
    
    @version.setter
    def version(self, value : int):
        '''Sets the version.'''
        ...
    
    @property
    def brightness(self) -> int:
        '''Gets the brightness.'''
        ...
    
    @brightness.setter
    def brightness(self, value : int):
        '''Sets the brightness.'''
        ...
    
    @property
    def contrast(self) -> int:
        '''Gets the contrast.'''
        ...
    
    @contrast.setter
    def contrast(self, value : int):
        '''Sets the contrast.'''
        ...
    
    @property
    def mean_value_for_brightness_and_contrast(self) -> int:
        ...
    
    @mean_value_for_brightness_and_contrast.setter
    def mean_value_for_brightness_and_contrast(self, value : int):
        ...
    
    @property
    def lab_color(self) -> bool:
        ...
    
    @lab_color.setter
    def lab_color(self, value : bool):
        ...
    
    @property
    def use_legacy(self) -> bool:
        ...
    
    @use_legacy.setter
    def use_legacy(self, value : bool):
        ...
    
    @property
    def auto(self) -> bool:
        '''Gets a value indicating whether this :py:class:`aspose.psd.fileformats.psd.layers.layerresources.CgEdResource` is automatic.'''
        ...
    
    @auto.setter
    def auto(self, value : bool):
        '''Sets a value indicating whether this :py:class:`aspose.psd.fileformats.psd.layers.layerresources.CgEdResource` is automatic.'''
        ...
    
    @classmethod
    @property
    def TYPE_TOOL_KEY(cls) -> int:
        ...
    
    ...

class ClassID:
    '''The PSD Class ID object.'''
    
    def save(self, stream_container : aspose.psd.StreamContainer):
        '''Saves the class information to the specified stream container.
        
        :param stream_container: The stream container to save to.'''
        ...
    
    @property
    def bytes(self) -> bytes:
        '''Gets the bytes representing class ID.'''
        ...
    
    @property
    def class_name(self) -> str:
        ...
    
    @property
    def length(self) -> int:
        '''Gets the class ID length in bytes.'''
        ...
    
    ...

class ClblResource(BooleanResource):
    '''Class ClblResource.
    This resource contains information about blending of clipped element.'''
    
    def save(self, stream_container : aspose.psd.StreamContainer, psd_version : int):
        '''Saves the specified stream container.
        
        :param stream_container: The stream container.
        :param psd_version: The PSD version.'''
        ...
    
    @property
    def signature(self) -> int:
        '''Gets the signature.'''
        ...
    
    @property
    def key(self) -> int:
        '''Gets the layer resource key.'''
        ...
    
    @property
    def length(self) -> int:
        '''Gets the layer resource length in bytes.'''
        ...
    
    @property
    def psd_version(self) -> int:
        ...
    
    @classmethod
    @property
    def RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @classmethod
    @property
    def PSB_RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @property
    def blend_clipped_elements(self) -> bool:
        ...
    
    @blend_clipped_elements.setter
    def blend_clipped_elements(self, value : bool):
        ...
    
    @classmethod
    @property
    def TYPE_TOOL_KEY(cls) -> int:
        ...
    
    ...

class CmlsResource(aspose.psd.fileformats.psd.layers.LayerResource):
    '''Class CmlsResource.'''
    
    def save(self, stream_container : aspose.psd.StreamContainer, psd_version : int):
        '''Saves the resource to the specified stream container.
        
        :param stream_container: The stream container to save to.
        :param psd_version: The PSD version.'''
        ...
    
    @property
    def signature(self) -> int:
        '''Gets the signature.'''
        ...
    
    @property
    def key(self) -> int:
        '''Gets the layer resource key.'''
        ...
    
    @property
    def length(self) -> int:
        '''Gets the layer resource length in bytes.'''
        ...
    
    @property
    def psd_version(self) -> int:
        ...
    
    @classmethod
    @property
    def RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @classmethod
    @property
    def PSB_RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @classmethod
    @property
    def TYPE_TOOL_KEY(cls) -> int:
        ...
    
    ...

class ColorRangeHsl:
    ''':py:class:`aspose.psd.fileformats.psd.layers.layerresources.Hue2Resource` has 6 color ranges where you can change HSV parameters.
    Every range has 4 key points to identify range borders. And it's ColorRangeHsl'''
    
    def is_hue_in_big_range(self, hue : float) -> bool:
        '''Determines whether is hue in big range.
        
        :param hue: The hue value.
        :returns: ``true`` if hue in big range; otherwise, ``false``.'''
        ...
    
    def is_hue_in_small_range(self, hue : float) -> bool:
        '''Determines whether hue in small range.
        
        :param hue: The hue value.
        :returns: ``true`` if hue in small range; otherwise, ``false``.'''
        ...
    
    def get_range_coefficient(self, hue : float) -> float:
        '''Gets the range Coefficient.
        
        :param hue: The hue value.
        :returns: Saturation range coefficient.'''
        ...
    
    def save(self, stream_container : aspose.psd.StreamContainer):
        '''Saves data to the specified stream container.
        
        :param stream_container: The stream container.'''
        ...
    
    @property
    def hue(self) -> int:
        '''Gets the hue.'''
        ...
    
    @hue.setter
    def hue(self, value : int):
        '''Sets the hue.'''
        ...
    
    @property
    def saturation(self) -> int:
        '''Gets the saturation.'''
        ...
    
    @saturation.setter
    def saturation(self, value : int):
        '''Sets the saturation.'''
        ...
    
    @property
    def lightness(self) -> int:
        '''Gets the lightness.'''
        ...
    
    @lightness.setter
    def lightness(self, value : int):
        '''Sets the lightness.'''
        ...
    
    @property
    def most_left_border(self) -> int:
        ...
    
    @most_left_border.setter
    def most_left_border(self, value : int):
        ...
    
    @property
    def left_border(self) -> int:
        ...
    
    @left_border.setter
    def left_border(self, value : int):
        ...
    
    @property
    def right_border(self) -> int:
        ...
    
    @right_border.setter
    def right_border(self, value : int):
        ...
    
    @property
    def most_right_border(self) -> int:
        ...
    
    @most_right_border.setter
    def most_right_border(self, value : int):
        ...
    
    ...

class CurvResource(AdjustmentLayerResource):
    '''Class CurvResource. Resource of Curves Adjustment Layer
    1 byte - 0 if use curves, 1 if used pixels on map
    if 0 then:
    2 bytes - short.  Default is 1
    4 bytes - int. Used only last byte by bit. First bit is for 1 channel, the Fourth bit for 4 channel for example
    2 bytes - short points count
    4 bytes * count of point - points of curve 2 short: first position, second height
    4 bytes - word "Crv "
    2 bytes - short default is 4 for Curves
    4 bytes - int. Default is 1
    4 bytes - point count
    4 bytes * point count - points of curve 2 short: first position, second height
    0-4 bytes - Leading to be fold for four
    if 1 then:
    2 bytes - short. Default is 1
    4 bytes - int. Used only last byte. One channel is in one bit. First bit is for 1 channel, the Fourth bit for 4 channel for example
    256 * count of changed channels - ordered values of channel in range 0 - 255
    4 bytes - word "Crv "
    2 bytes - short. Default is 3 for pixels on map
    4 bytes - int Channel count
    (2 + 256) bytes - short 2 for channel index, 256 is ordered values of channel in range 0 - 255'''
    
    def save(self, stream_container : aspose.psd.StreamContainer, psd_version : int):
        '''Saves the resource to the specified stream container.
        
        :param stream_container: The stream container to save to.
        :param psd_version: The PSD version.'''
        ...
    
    def get_channel_data(self, channel_index : int) -> bytes:
        '''Gets the channel data.
        
        :param channel_index: Index of the channel.
        :returns: Channel data'''
        ...
    
    def get_active_manager(self) -> aspose.psd.fileformats.psd.layers.layerresources.CurvesManager:
        '''Gets the active manager.
        
        :returns: Active manager'''
        ...
    
    def get_curve_manager(self) -> aspose.psd.fileformats.psd.layers.layerresources.CurvesManager:
        '''Gets the curve manager.
        
        :returns: :py:class:`aspose.psd.fileformats.psd.layers.layerresources.CurvesDiscreteManager` or :py:class:`aspose.psd.fileformats.psd.layers.layerresources.CurvesContinuousManager`'''
        ...
    
    @property
    def signature(self) -> int:
        '''Gets the signature.'''
        ...
    
    @property
    def key(self) -> int:
        '''Gets the layer resource key.'''
        ...
    
    @property
    def length(self) -> int:
        '''Gets the layer resource length in bytes.'''
        ...
    
    @property
    def psd_version(self) -> int:
        ...
    
    @classmethod
    @property
    def RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @classmethod
    @property
    def PSB_RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @property
    def is_data_stored_discretely(self) -> bool:
        ...
    
    @is_data_stored_discretely.setter
    def is_data_stored_discretely(self, value : bool):
        ...
    
    @classmethod
    @property
    def TYPE_TOOL_KEY(cls) -> int:
        ...
    
    ...

class CurvesContinuousManager(CurvesManager):
    '''Manager for Curves Adjustment Layer that manipulates curves'''
    
    def update_curve_point(self, channel_index : int, point_index : int, x : byte, y : byte):
        '''Updates the point of curve.
        
        :param channel_index: Index of the channel.
        :param point_index: Index of the point.
        :param x: The x location.
        :param y: The y location.'''
        ...
    
    def add_curve_point(self, channel_index : int, x : byte, y : byte):
        '''Adds the point of curve.
        
        :param channel_index: Index of the channel.
        :param x: The x location.
        :param y: The y location.'''
        ...
    
    def get_curve_point_by_index(self, channel_index : int, point_index : int) -> aspose.psd.Point:
        '''Gets the curve point by index.
        
        :param channel_index: Index of the channel.
        :param point_index: Index of the point.
        :returns: Curve point by index of channel'''
        ...
    
    def get_curve_point_count(self, channel_index : int) -> int:
        '''Gets the curve point count.
        
        :param channel_index: Index of the channel.
        :returns: Count of Curve Point in channel'''
        ...
    
    def remove_curve_point(self, channel_index : int, point_index : int):
        '''Removes the point of curve.
        
        :param channel_index: Index of the channel.
        :param point_index: Index of the point.'''
        ...
    
    @property
    def max_channel_count(self) -> int:
        ...
    
    ...

class CurvesDiscreteManager(CurvesManager):
    '''Manager for Curves Adjustment Layer that manipulates pixels' map'''
    
    def set_value_in_position(self, channel_index : int, position : byte, value : byte):
        '''Sets the value in position.
        
        :param channel_index: Index of the channel.
        :param position: The position.
        :param value: The value.'''
        ...
    
    def get_value_in_position(self, channel_index : int, position : byte) -> byte:
        '''Gets the value in position.
        
        :param channel_index: Index of the channel.
        :param position: The position.
        :returns: Value of curve by its position'''
        ...
    
    def set_to_default_value_in_position(self, channel_index : int, position : byte):
        '''Sets to default value in position.
        
        :param channel_index: Index of the channel.
        :param position: The position.'''
        ...
    
    def set_value_of_whole_channel(self, channel_index : int, channel_value : bytes):
        '''Sets the value of whole channel.
        
        :param channel_index: Index of the channel.
        :param channel_value: The channel value.'''
        ...
    
    @property
    def max_channel_count(self) -> int:
        ...
    
    ...

class CurvesManager:
    '''Base Class to manage CurvResource'''
    
    @property
    def max_channel_count(self) -> int:
        ...
    
    ...

class CustResource(aspose.psd.fileformats.psd.layers.LayerResource):
    '''Class CustResource.
    This resource contains information about blending of clipped element.'''
    
    def save(self, stream_container : aspose.psd.StreamContainer, psd_version : int):
        '''Saves the resource to the specified stream container.
        
        :param stream_container: The stream container to save to.
        :param psd_version: The PSD version.'''
        ...
    
    @property
    def signature(self) -> int:
        '''Gets the signature.'''
        ...
    
    @property
    def key(self) -> int:
        '''Gets the layer resource key.'''
        ...
    
    @property
    def length(self) -> int:
        '''Gets the layer resource length in bytes.'''
        ...
    
    @property
    def psd_version(self) -> int:
        ...
    
    @classmethod
    @property
    def RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @classmethod
    @property
    def PSB_RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @property
    def layer_created_date_time(self) -> DateTime:
        ...
    
    @layer_created_date_time.setter
    def layer_created_date_time(self, value : DateTime):
        ...
    
    @classmethod
    @property
    def TYPE_TOOL_KEY(cls) -> int:
        ...
    
    ...

class ExpaResource(AdjustmentLayerResource):
    '''Class ExpaResource. Resource of Exposure Adjustment Layer'''
    
    def save(self, stream_container : aspose.psd.StreamContainer, psd_version : int):
        '''Saves the resource to the specified stream container.
        
        :param stream_container: The stream container to save to.
        :param psd_version: The PSD version.'''
        ...
    
    @property
    def signature(self) -> int:
        '''Gets the signature.'''
        ...
    
    @property
    def key(self) -> int:
        '''Gets the layer resource key.'''
        ...
    
    @property
    def length(self) -> int:
        '''Gets the layer resource length in bytes.'''
        ...
    
    @property
    def psd_version(self) -> int:
        ...
    
    @classmethod
    @property
    def RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @classmethod
    @property
    def PSB_RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @property
    def version(self) -> int:
        '''Gets the version. Default is 1'''
        ...
    
    @property
    def exposure(self) -> float:
        '''Gets the exposure.'''
        ...
    
    @exposure.setter
    def exposure(self, value : float):
        '''Sets the exposure.'''
        ...
    
    @property
    def offset(self) -> float:
        '''Gets the offset.'''
        ...
    
    @offset.setter
    def offset(self, value : float):
        '''Sets the offset.'''
        ...
    
    @property
    def gamma_correction(self) -> float:
        ...
    
    @gamma_correction.setter
    def gamma_correction(self, value : float):
        ...
    
    @classmethod
    @property
    def TYPE_TOOL_KEY(cls) -> int:
        ...
    
    ...

class FXidResource(aspose.psd.fileformats.psd.layers.LayerResource):
    '''The Filter Effects resource contains channels, a user mask, and a sheet mask for the smart filter.'''
    
    def save(self, stream_container : aspose.psd.StreamContainer, psd_version : int):
        '''Saves the resource to the specified stream container.
        
        :param stream_container: The stream container to save to.
        :param psd_version: The PSD version.'''
        ...
    
    @property
    def signature(self) -> int:
        '''Gets the layer resource signature.'''
        ...
    
    @property
    def key(self) -> int:
        '''Gets the layer resource key.'''
        ...
    
    @property
    def length(self) -> int:
        '''Gets the layer resource length in bytes.'''
        ...
    
    @property
    def psd_version(self) -> int:
        ...
    
    @classmethod
    @property
    def RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @classmethod
    @property
    def PSB_RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @property
    def version(self) -> int:
        '''Gets the version.'''
        ...
    
    @property
    def filter_effect_masks(self) -> List[aspose.psd.fileformats.psd.layers.layerresources.FilterEffectMaskData]:
        ...
    
    @classmethod
    @property
    def F_EID_TYPE_TOOL_KEY(cls) -> int:
        ...
    
    @classmethod
    @property
    def F_XID_TYPE_TOOL_KEY(cls) -> int:
        ...
    
    ...

class FillLayerResource(aspose.psd.fileformats.psd.layers.LayerResource):
    '''Base Class for fill layer resources'''
    
    def save(self, stream_container : aspose.psd.StreamContainer, psd_version : int):
        '''Saves the resource to the specified stream container.
        
        :param stream_container: The stream container to save to.
        :param psd_version: The PSD version.'''
        ...
    
    @property
    def signature(self) -> int:
        '''Gets the signature.'''
        ...
    
    @property
    def key(self) -> int:
        '''Gets the layer resource key.'''
        ...
    
    @property
    def length(self) -> int:
        '''Gets the layer resource length in bytes.'''
        ...
    
    @property
    def psd_version(self) -> int:
        ...
    
    @classmethod
    @property
    def RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @classmethod
    @property
    def PSB_RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    ...

class FilterEffectMaskData:
    '''The filter mask data class.'''
    
    def save_data(self, stream_container : aspose.psd.StreamContainer):
        '''Saves the resource to the specified stream container.
        
        :param stream_container: The stream container to save to.'''
        ...
    
    @property
    def length(self) -> int:
        '''Gets the filter mask data length in bytes.'''
        ...
    
    @property
    def guid(self) -> str:
        '''Gets the GUID.'''
        ...
    
    @property
    def rectangle(self) -> aspose.psd.Rectangle:
        '''Gets the channels rectangle.'''
        ...
    
    @property
    def pixels_depth(self) -> int:
        ...
    
    @property
    def max_channels(self) -> int:
        ...
    
    @property
    def channels(self) -> List[aspose.psd.fileformats.psd.layers.ChannelInformation]:
        '''Gets the channels.'''
        ...
    
    @property
    def user_mask(self) -> aspose.psd.fileformats.psd.layers.ChannelInformation:
        ...
    
    @property
    def mask_rectangle(self) -> aspose.psd.Rectangle:
        ...
    
    @property
    def sheet_mask(self) -> aspose.psd.fileformats.psd.layers.ChannelInformation:
        ...
    
    ...

class FxrpResource(aspose.psd.fileformats.psd.layers.LayerResource):
    '''Class FxrpResource. The reference point of layer'''
    
    def save(self, stream_container : aspose.psd.StreamContainer, psd_version : int):
        '''Saves to the specified stream container.
        
        :param stream_container: The stream container.
        :param psd_version: The PSD version.'''
        ...
    
    @property
    def signature(self) -> int:
        '''Gets the signature.'''
        ...
    
    @property
    def key(self) -> int:
        '''Gets the layer resource key.'''
        ...
    
    @property
    def length(self) -> int:
        '''Gets the layer resource length in bytes.'''
        ...
    
    @property
    def psd_version(self) -> int:
        ...
    
    @classmethod
    @property
    def RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @classmethod
    @property
    def PSB_RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @property
    def x(self) -> float:
        '''Gets the x of reference point'''
        ...
    
    @x.setter
    def x(self, value : float):
        '''Sets the x of reference point'''
        ...
    
    @property
    def y(self) -> float:
        '''Gets the y of reference point'''
        ...
    
    @y.setter
    def y(self, value : float):
        '''Sets the y of reference point'''
        ...
    
    @classmethod
    @property
    def TYPE_TOOL_KEY(cls) -> int:
        ...
    
    ...

class GdFlResource(FillLayerResource):
    '''Class GdFlResource.
    This resource contains information about blending of clipped element.'''
    
    def save(self, stream_container : aspose.psd.StreamContainer, psd_version : int):
        '''Saves the resource to the specified stream container.
        
        :param stream_container: The stream container to save to.
        :param psd_version: The PSD version.'''
        ...
    
    @property
    def signature(self) -> int:
        '''Gets the layer resource signature.'''
        ...
    
    @property
    def key(self) -> int:
        '''Gets the layer resource key.'''
        ...
    
    @property
    def length(self) -> int:
        '''Gets the layer resource length in bytes.'''
        ...
    
    @property
    def psd_version(self) -> int:
        ...
    
    @classmethod
    @property
    def RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @classmethod
    @property
    def PSB_RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @property
    def color(self) -> aspose.psd.Color:
        '''Gets the color of the RGB.'''
        ...
    
    @color.setter
    def color(self, value : aspose.psd.Color):
        '''Gets the color of the RGB.'''
        ...
    
    @property
    def angle(self) -> float:
        '''Gets the angle.'''
        ...
    
    @angle.setter
    def angle(self, value : float):
        '''Sets the angle.'''
        ...
    
    @property
    def horizontal_offset(self) -> float:
        ...
    
    @horizontal_offset.setter
    def horizontal_offset(self, value : float):
        ...
    
    @property
    def vertical_offset(self) -> float:
        ...
    
    @vertical_offset.setter
    def vertical_offset(self, value : float):
        ...
    
    @property
    def gradient_type(self) -> aspose.psd.fileformats.psd.layers.fillsettings.GradientType:
        ...
    
    @gradient_type.setter
    def gradient_type(self, value : aspose.psd.fileformats.psd.layers.fillsettings.GradientType):
        ...
    
    @property
    def gradient_mode(self) -> str:
        ...
    
    @gradient_mode.setter
    def gradient_mode(self, value : str):
        ...
    
    @property
    def rnd_number_seed(self) -> int:
        ...
    
    @rnd_number_seed.setter
    def rnd_number_seed(self, value : int):
        ...
    
    @property
    def show_transparency(self) -> bool:
        ...
    
    @show_transparency.setter
    def show_transparency(self, value : bool):
        ...
    
    @property
    def use_vector_color(self) -> bool:
        ...
    
    @use_vector_color.setter
    def use_vector_color(self, value : bool):
        ...
    
    @property
    def roughness(self) -> int:
        '''Roughness factor.'''
        ...
    
    @roughness.setter
    def roughness(self, value : int):
        '''Roughness factor.'''
        ...
    
    @property
    def color_model(self) -> str:
        ...
    
    @color_model.setter
    def color_model(self, value : str):
        ...
    
    @property
    def minimum_color(self) -> aspose.psd.fileformats.psd.core.rawcolor.RawColor:
        ...
    
    @minimum_color.setter
    def minimum_color(self, value : aspose.psd.fileformats.psd.core.rawcolor.RawColor):
        ...
    
    @property
    def maximum_color(self) -> aspose.psd.fileformats.psd.core.rawcolor.RawColor:
        ...
    
    @maximum_color.setter
    def maximum_color(self, value : aspose.psd.fileformats.psd.core.rawcolor.RawColor):
        ...
    
    @property
    def color_points(self) -> List[aspose.psd.fileformats.psd.layers.IGradientColorPoint]:
        ...
    
    @color_points.setter
    def color_points(self, value : List[aspose.psd.fileformats.psd.layers.IGradientColorPoint]):
        ...
    
    @property
    def transparency_points(self) -> List[aspose.psd.fileformats.psd.layers.fillsettings.IGradientTransparencyPoint]:
        ...
    
    @transparency_points.setter
    def transparency_points(self, value : List[aspose.psd.fileformats.psd.layers.fillsettings.IGradientTransparencyPoint]):
        ...
    
    @property
    def gradient_name(self) -> str:
        ...
    
    @gradient_name.setter
    def gradient_name(self, value : str):
        ...
    
    @property
    def gradient_interval(self) -> float:
        ...
    
    @gradient_interval.setter
    def gradient_interval(self, value : float):
        ...
    
    @property
    def scale(self) -> int:
        '''Gets the scale.'''
        ...
    
    @scale.setter
    def scale(self, value : int):
        '''Sets the scale.'''
        ...
    
    @property
    def reverse(self) -> bool:
        '''Gets a value indicating whether this :py:class:`aspose.psd.fileformats.psd.layers.layerresources.GdFlResource` is reverse.'''
        ...
    
    @reverse.setter
    def reverse(self, value : bool):
        '''Sets a value indicating whether this :py:class:`aspose.psd.fileformats.psd.layers.layerresources.GdFlResource` is reverse.'''
        ...
    
    @property
    def dither(self) -> bool:
        '''Gets a value indicating whether this :py:class:`aspose.psd.fileformats.psd.layers.layerresources.GdFlResource` is dither.'''
        ...
    
    @dither.setter
    def dither(self, value : bool):
        '''Sets a value indicating whether this :py:class:`aspose.psd.fileformats.psd.layers.layerresources.GdFlResource` is dither.'''
        ...
    
    @property
    def align_with_layer(self) -> bool:
        ...
    
    @align_with_layer.setter
    def align_with_layer(self, value : bool):
        ...
    
    @classmethod
    @property
    def TYPE_TOOL_KEY(cls) -> int:
        ...
    
    ...

class GrdmResource(aspose.psd.fileformats.psd.layers.LayerResource):
    '''Class GrdmResource. Contains information about Gradient-Map layer.'''
    
    def save(self, stream_container : aspose.psd.StreamContainer, psd_version : int):
        '''Saves resource data to the specified stream container.
        
        :param stream_container: The stream container.
        :param psd_version: The PSD version.'''
        ...
    
    def set_psd_version(self, value : int):
        '''Sets the minimal psd version required for layer resource. 0 indicates no restrictions.
        
        :param value: Psdversion value'''
        ...
    
    @property
    def signature(self) -> int:
        '''Gets the signature.'''
        ...
    
    @property
    def key(self) -> int:
        '''Gets the layer resource key.'''
        ...
    
    @property
    def length(self) -> int:
        '''Gets the layer resource length in bytes.'''
        ...
    
    @property
    def psd_version(self) -> int:
        ...
    
    @classmethod
    @property
    def RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @classmethod
    @property
    def PSB_RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @property
    def reverse(self) -> bool:
        '''Is gradient reversed.'''
        ...
    
    @reverse.setter
    def reverse(self, value : bool):
        '''Is gradient reversed.'''
        ...
    
    @property
    def dither(self) -> bool:
        '''Is gradient dithered.'''
        ...
    
    @dither.setter
    def dither(self, value : bool):
        '''Is gradient dithered.'''
        ...
    
    @property
    def gradient_name(self) -> str:
        ...
    
    @gradient_name.setter
    def gradient_name(self, value : str):
        ...
    
    @property
    def expansion_count(self) -> int:
        ...
    
    @expansion_count.setter
    def expansion_count(self, value : int):
        ...
    
    @property
    def interpolation(self) -> int:
        '''Interpolation. Determines Smoothness, when 'Gradient Type' = 'Solid' (GradientMode = 0).'''
        ...
    
    @interpolation.setter
    def interpolation(self, value : int):
        '''Interpolation. Determines Smoothness, when 'Gradient Type' = 'Solid' (GradientMode = 0).'''
        ...
    
    @property
    def gradient_mode(self) -> aspose.psd.fileformats.psd.layers.gradient.GradientKind:
        ...
    
    @gradient_mode.setter
    def gradient_mode(self, value : aspose.psd.fileformats.psd.layers.gradient.GradientKind):
        ...
    
    @property
    def rnd_number_seed(self) -> int:
        ...
    
    @rnd_number_seed.setter
    def rnd_number_seed(self, value : int):
        ...
    
    @property
    def show_transparency(self) -> int:
        ...
    
    @show_transparency.setter
    def show_transparency(self, value : int):
        ...
    
    @property
    def use_vector_color(self) -> int:
        ...
    
    @use_vector_color.setter
    def use_vector_color(self, value : int):
        ...
    
    @property
    def roughness(self) -> int:
        '''Roughness factor
        When 'Gradient type' = 'Noise', we can assign 'Roughness' (0 - 2048).'''
        ...
    
    @roughness.setter
    def roughness(self, value : int):
        '''Roughness factor
        When 'Gradient type' = 'Noise', we can assign 'Roughness' (0 - 2048).'''
        ...
    
    @property
    def color_model(self) -> int:
        ...
    
    @color_model.setter
    def color_model(self, value : int):
        ...
    
    @property
    def color_points(self) -> List[aspose.psd.fileformats.psd.layers.IGradientColorPoint]:
        ...
    
    @color_points.setter
    def color_points(self, value : List[aspose.psd.fileformats.psd.layers.IGradientColorPoint]):
        ...
    
    @property
    def transparency_points(self) -> List[aspose.psd.fileformats.psd.layers.fillsettings.IGradientTransparencyPoint]:
        ...
    
    @transparency_points.setter
    def transparency_points(self, value : List[aspose.psd.fileformats.psd.layers.fillsettings.IGradientTransparencyPoint]):
        ...
    
    @property
    def minimum_color(self) -> aspose.psd.fileformats.psd.core.rawcolor.RawColor:
        ...
    
    @property
    def maximum_color(self) -> aspose.psd.fileformats.psd.core.rawcolor.RawColor:
        ...
    
    @classmethod
    @property
    def TYPE_TOOL_KEY(cls) -> int:
        ...
    
    ...

class Hue2Resource(AdjustmentLayerResource):
    '''Class Hue2Resource. Resource of Exposure Adjustment Layer'''
    
    def save(self, stream_container : aspose.psd.StreamContainer, psd_version : int):
        '''Saves the resource to the specified stream container.
        
        :param stream_container: The stream container to save to.
        :param psd_version: The PSD version.'''
        ...
    
    @property
    def signature(self) -> int:
        '''Gets the signature.'''
        ...
    
    @property
    def key(self) -> int:
        '''Gets the layer resource key.'''
        ...
    
    @property
    def length(self) -> int:
        '''Gets the layer resource length in bytes.'''
        ...
    
    @property
    def psd_version(self) -> int:
        ...
    
    @classmethod
    @property
    def RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @classmethod
    @property
    def PSB_RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @property
    def version(self) -> int:
        '''Gets the version. Default is 2'''
        ...
    
    @property
    def colorize(self) -> bool:
        '''Gets a value indicating whether this :py:class:`aspose.psd.fileformats.psd.layers.layerresources.Hue2Resource` is colorize.'''
        ...
    
    @colorize.setter
    def colorize(self, value : bool):
        '''Sets a value indicating whether this :py:class:`aspose.psd.fileformats.psd.layers.layerresources.Hue2Resource` is colorize.'''
        ...
    
    @property
    def hue(self) -> int:
        '''Gets the master hue.'''
        ...
    
    @hue.setter
    def hue(self, value : int):
        '''Sets the master hue.'''
        ...
    
    @property
    def saturation(self) -> int:
        '''Gets the master saturation.'''
        ...
    
    @saturation.setter
    def saturation(self, value : int):
        '''Sets the master saturation.'''
        ...
    
    @property
    def lightness(self) -> int:
        '''Gets the master lightness.'''
        ...
    
    @lightness.setter
    def lightness(self, value : int):
        '''Sets the master lightness.'''
        ...
    
    @property
    def ranges(self) -> List[aspose.psd.fileformats.psd.layers.layerresources.ColorRangeHsl]:
        '''Gets the ranges of Hue/Saturation Adjustment Layer.
        Ranges in PS can change names if range is changed, so we should work by index'''
        ...
    
    @classmethod
    @property
    def TYPE_TOOL_KEY(cls) -> int:
        ...
    
    ...

class IOSTypeStructureLoader:
    '''The :py:class:`aspose.psd.fileformats.psd.layers.layerresources.OSTypeStructure` resource loader.'''
    
    def can_load(self, stream_container : aspose.psd.StreamContainer) -> bool:
        '''Determines whether :py:class:`aspose.psd.fileformats.psd.layers.layerresources.OSTypeStructure` resource can be loaded from the specified :py:class:`aspose.psd.StreamContainer`.
        
        :param stream_container: The stream container.
        :returns: ``true`` if :py:class:`aspose.psd.fileformats.psd.layers.layerresources.OSTypeStructure` resource can be loaded from the specified :py:class:`aspose.psd.StreamContainer`; otherwise, ``false``.'''
        ...
    
    def load(self, stream_container : aspose.psd.StreamContainer) -> aspose.psd.fileformats.psd.layers.layerresources.OSTypeStructure:
        '''Loads the :py:class:`aspose.psd.fileformats.psd.layers.layerresources.OSTypeStructure`.
        
        :param stream_container: The stream container to load from.
        :returns: The loaded :py:class:`aspose.psd.fileformats.psd.layers.layerresources.OSTypeStructure` resource.'''
        ...
    
    ...

class IPath:
    '''Interface describes the set of Paths that present in a Shape layer.'''
    
    def get_items(self) -> List[aspose.psd.fileformats.psd.layers.layerresources.IPathShape]:
        '''Gets array of Shapes in a Path.
        
        :returns: Array of IPathShape.'''
        ...
    
    def set_items(self, shapes : List[aspose.psd.fileformats.psd.layers.layerresources.IPathShape]):
        '''Sets array of Shapes in a Path.
        
        :param shapes: Array of IPathShape.'''
        ...
    
    @property
    def is_inverted(self) -> bool:
        ...
    
    @is_inverted.setter
    def is_inverted(self, value : bool):
        ...
    
    @property
    def is_not_linked(self) -> bool:
        ...
    
    @is_not_linked.setter
    def is_not_linked(self, value : bool):
        ...
    
    @property
    def is_disabled(self) -> bool:
        ...
    
    @is_disabled.setter
    def is_disabled(self, value : bool):
        ...
    
    ...

class IPathShape:
    '''The Shape from the knots of the Bezier curve.'''
    
    def get_items(self) -> List[aspose.psd.fileformats.core.vectorpaths.BezierKnotRecord]:
        '''Gets array of Bezier knots.
        
        :returns: Array of BezierKnotRecord.'''
        ...
    
    def set_items(self, bezier_points : List[aspose.psd.fileformats.core.vectorpaths.BezierKnotRecord]):
        '''Assignes array of Bexier knots.
        
        :param bezier_points: Array of bezier knots'''
        ...
    
    @property
    def is_closed(self) -> bool:
        ...
    
    @is_closed.setter
    def is_closed(self, value : bool):
        ...
    
    @property
    def path_operations(self) -> aspose.psd.fileformats.core.vectorpaths.PathOperations:
        ...
    
    @path_operations.setter
    def path_operations(self, value : aspose.psd.fileformats.core.vectorpaths.PathOperations):
        ...
    
    ...

class IPlacedLayerResource:
    '''Defines the IPlacedLayerResource interface that contains information about a placed layer in the PSD file.
    Is is a markup interface used to designate PlLd, Sold and Sole resources in the Adobe® Photoshop® images.
    Is is used to support smart object layers in the Adobe® Photoshop® images.'''
    
    @property
    def version(self) -> int:
        '''Gets the version of the placed layer in the PSD file, usually 3-5.'''
        ...
    
    @property
    def unique_id(self) -> Guid:
        ...
    
    @unique_id.setter
    def unique_id(self, value : Guid):
        ...
    
    @property
    def is_custom(self) -> bool:
        ...
    
    @is_custom.setter
    def is_custom(self, value : bool):
        ...
    
    @property
    def page_number(self) -> int:
        ...
    
    @page_number.setter
    def page_number(self, value : int):
        ...
    
    @property
    def total_pages(self) -> int:
        ...
    
    @total_pages.setter
    def total_pages(self, value : int):
        ...
    
    @property
    def anti_alias_policy(self) -> int:
        ...
    
    @anti_alias_policy.setter
    def anti_alias_policy(self, value : int):
        ...
    
    @property
    def placed_layer_type(self) -> aspose.psd.fileformats.psd.layers.layerresources.PlacedLayerType:
        ...
    
    @placed_layer_type.setter
    def placed_layer_type(self, value : aspose.psd.fileformats.psd.layers.layerresources.PlacedLayerType):
        ...
    
    @property
    def left(self) -> float:
        '''Gets the left location of the placed layer in the PSD file.'''
        ...
    
    @left.setter
    def left(self, value : float):
        '''Sets the left location of the placed layer in the PSD file.'''
        ...
    
    @property
    def top(self) -> float:
        '''Gets the top location of the placed layer in the PSD image.'''
        ...
    
    @top.setter
    def top(self, value : float):
        '''Sets the top location of the placed layer in the PSD image.'''
        ...
    
    @property
    def right(self) -> float:
        '''Gets the right location of the placed layer in the PSD file.'''
        ...
    
    @right.setter
    def right(self, value : float):
        '''Sets the right location of the placed layer in the PSD file.'''
        ...
    
    @property
    def bottom(self) -> float:
        '''Gets the bottom location of the placed layer in the PSD image.'''
        ...
    
    @bottom.setter
    def bottom(self, value : float):
        '''Sets the bottom location of the placed layer in the PSD image.'''
        ...
    
    @property
    def bounds(self) -> aspose.psd.Rectangle:
        '''Gets the bounds of the placed layer in the PSD file.'''
        ...
    
    @bounds.setter
    def bounds(self, value : aspose.psd.Rectangle):
        '''Sets the bounds of the placed layer in the PSD file.'''
        ...
    
    @property
    def transform_matrix(self) -> List[float]:
        ...
    
    @transform_matrix.setter
    def transform_matrix(self, value : List[float]):
        ...
    
    @property
    def horizontal_mesh_points(self) -> List[float]:
        ...
    
    @horizontal_mesh_points.setter
    def horizontal_mesh_points(self, value : List[float]):
        ...
    
    @property
    def vertical_mesh_points(self) -> List[float]:
        ...
    
    @vertical_mesh_points.setter
    def vertical_mesh_points(self, value : List[float]):
        ...
    
    @property
    def horizontal_mesh_point_unit(self) -> aspose.psd.fileformats.psd.layers.layerresources.typetoolinfostructures.UnitTypes:
        ...
    
    @horizontal_mesh_point_unit.setter
    def horizontal_mesh_point_unit(self, value : aspose.psd.fileformats.psd.layers.layerresources.typetoolinfostructures.UnitTypes):
        ...
    
    @property
    def vertical_mesh_point_unit(self) -> aspose.psd.fileformats.psd.layers.layerresources.typetoolinfostructures.UnitTypes:
        ...
    
    @vertical_mesh_point_unit.setter
    def vertical_mesh_point_unit(self, value : aspose.psd.fileformats.psd.layers.layerresources.typetoolinfostructures.UnitTypes):
        ...
    
    @property
    def value(self) -> float:
        '''Gets the warp value of the placed layer in the PSD image.'''
        ...
    
    @value.setter
    def value(self, value : float):
        '''Sets the warp value of the placed layer in the PSD image.'''
        ...
    
    @property
    def perspective(self) -> float:
        '''Gets the perspective value of the placed layer in the PSD file.'''
        ...
    
    @perspective.setter
    def perspective(self, value : float):
        '''Sets the perspective value of the placed layer in the PSD file.'''
        ...
    
    @property
    def perspective_other(self) -> float:
        ...
    
    @perspective_other.setter
    def perspective_other(self, value : float):
        ...
    
    @property
    def u_order(self) -> int:
        ...
    
    @u_order.setter
    def u_order(self, value : int):
        ...
    
    @property
    def v_order(self) -> int:
        ...
    
    @v_order.setter
    def v_order(self, value : int):
        ...
    
    @property
    def items(self) -> List[aspose.psd.fileformats.psd.layers.layerresources.OSTypeStructure]:
        '''Gets the warp items.'''
        ...
    
    @items.setter
    def items(self, value : List[aspose.psd.fileformats.psd.layers.layerresources.OSTypeStructure]):
        '''Sets the warp items.'''
        ...
    
    ...

class ISmartObjectLayerResource(IPlacedLayerResource):
    '''Defines the ISmartObjectLayerResource interface that contains information about a smart object layer resource in the PSD file.
    Is is also a markup interface used to designate both Sold and Sole resources in the Adobe® Photoshop® images.'''
    
    @property
    def placed_id(self) -> Guid:
        ...
    
    @placed_id.setter
    def placed_id(self, value : Guid):
        ...
    
    @property
    def version(self) -> int:
        '''Gets the version of the placed layer in the PSD file, usually 3-5.'''
        ...
    
    @property
    def unique_id(self) -> Guid:
        ...
    
    @unique_id.setter
    def unique_id(self, value : Guid):
        ...
    
    @property
    def is_custom(self) -> bool:
        ...
    
    @is_custom.setter
    def is_custom(self, value : bool):
        ...
    
    @property
    def page_number(self) -> int:
        ...
    
    @page_number.setter
    def page_number(self, value : int):
        ...
    
    @property
    def total_pages(self) -> int:
        ...
    
    @total_pages.setter
    def total_pages(self, value : int):
        ...
    
    @property
    def anti_alias_policy(self) -> int:
        ...
    
    @anti_alias_policy.setter
    def anti_alias_policy(self, value : int):
        ...
    
    @property
    def placed_layer_type(self) -> aspose.psd.fileformats.psd.layers.layerresources.PlacedLayerType:
        ...
    
    @placed_layer_type.setter
    def placed_layer_type(self, value : aspose.psd.fileformats.psd.layers.layerresources.PlacedLayerType):
        ...
    
    @property
    def left(self) -> float:
        '''Gets the left location of the placed layer in the PSD file.'''
        ...
    
    @left.setter
    def left(self, value : float):
        '''Sets the left location of the placed layer in the PSD file.'''
        ...
    
    @property
    def top(self) -> float:
        '''Gets the top location of the placed layer in the PSD image.'''
        ...
    
    @top.setter
    def top(self, value : float):
        '''Sets the top location of the placed layer in the PSD image.'''
        ...
    
    @property
    def right(self) -> float:
        '''Gets the right location of the placed layer in the PSD file.'''
        ...
    
    @right.setter
    def right(self, value : float):
        '''Sets the right location of the placed layer in the PSD file.'''
        ...
    
    @property
    def bottom(self) -> float:
        '''Gets the bottom location of the placed layer in the PSD image.'''
        ...
    
    @bottom.setter
    def bottom(self, value : float):
        '''Sets the bottom location of the placed layer in the PSD image.'''
        ...
    
    @property
    def bounds(self) -> aspose.psd.Rectangle:
        '''Gets the bounds of the placed layer in the PSD file.'''
        ...
    
    @bounds.setter
    def bounds(self, value : aspose.psd.Rectangle):
        '''Sets the bounds of the placed layer in the PSD file.'''
        ...
    
    @property
    def transform_matrix(self) -> List[float]:
        ...
    
    @transform_matrix.setter
    def transform_matrix(self, value : List[float]):
        ...
    
    @property
    def horizontal_mesh_points(self) -> List[float]:
        ...
    
    @horizontal_mesh_points.setter
    def horizontal_mesh_points(self, value : List[float]):
        ...
    
    @property
    def vertical_mesh_points(self) -> List[float]:
        ...
    
    @vertical_mesh_points.setter
    def vertical_mesh_points(self, value : List[float]):
        ...
    
    @property
    def horizontal_mesh_point_unit(self) -> aspose.psd.fileformats.psd.layers.layerresources.typetoolinfostructures.UnitTypes:
        ...
    
    @horizontal_mesh_point_unit.setter
    def horizontal_mesh_point_unit(self, value : aspose.psd.fileformats.psd.layers.layerresources.typetoolinfostructures.UnitTypes):
        ...
    
    @property
    def vertical_mesh_point_unit(self) -> aspose.psd.fileformats.psd.layers.layerresources.typetoolinfostructures.UnitTypes:
        ...
    
    @vertical_mesh_point_unit.setter
    def vertical_mesh_point_unit(self, value : aspose.psd.fileformats.psd.layers.layerresources.typetoolinfostructures.UnitTypes):
        ...
    
    @property
    def value(self) -> float:
        '''Gets the warp value of the placed layer in the PSD image.'''
        ...
    
    @value.setter
    def value(self, value : float):
        '''Sets the warp value of the placed layer in the PSD image.'''
        ...
    
    @property
    def perspective(self) -> float:
        '''Gets the perspective value of the placed layer in the PSD file.'''
        ...
    
    @perspective.setter
    def perspective(self, value : float):
        '''Sets the perspective value of the placed layer in the PSD file.'''
        ...
    
    @property
    def perspective_other(self) -> float:
        ...
    
    @perspective_other.setter
    def perspective_other(self, value : float):
        ...
    
    @property
    def u_order(self) -> int:
        ...
    
    @u_order.setter
    def u_order(self, value : int):
        ...
    
    @property
    def v_order(self) -> int:
        ...
    
    @v_order.setter
    def v_order(self, value : int):
        ...
    
    @property
    def items(self) -> List[aspose.psd.fileformats.psd.layers.layerresources.OSTypeStructure]:
        '''Gets the warp items.'''
        ...
    
    @items.setter
    def items(self, value : List[aspose.psd.fileformats.psd.layers.layerresources.OSTypeStructure]):
        '''Sets the warp items.'''
        ...
    
    ...

class InfxResource(BooleanResource):
    '''Class InfxResource.
    This resource contains information about blending of clipped element.'''
    
    def save(self, stream_container : aspose.psd.StreamContainer, psd_version : int):
        '''Saves the specified stream container.
        
        :param stream_container: The stream container.
        :param psd_version: The PSD version.'''
        ...
    
    @property
    def signature(self) -> int:
        '''Gets the signature.'''
        ...
    
    @property
    def key(self) -> int:
        '''Gets the layer resource key.'''
        ...
    
    @property
    def length(self) -> int:
        '''Gets the layer resource length in bytes.'''
        ...
    
    @property
    def psd_version(self) -> int:
        ...
    
    @classmethod
    @property
    def RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @classmethod
    @property
    def PSB_RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @property
    def blend_interior_elements(self) -> bool:
        ...
    
    @blend_interior_elements.setter
    def blend_interior_elements(self, value : bool):
        ...
    
    @classmethod
    @property
    def TYPE_TOOL_KEY(cls) -> int:
        ...
    
    ...

class IopaResource(aspose.psd.fileformats.psd.layers.LayerResource):
    '''Class IopaResource.
    This resource contains information about the fill opacity property from the layer style form'''
    
    def save(self, stream_container : aspose.psd.StreamContainer, psd_version : int):
        '''Saves the resource to the specified stream container.
        
        :param stream_container: The stream container to save to.
        :param psd_version: The PSD version.'''
        ...
    
    @property
    def signature(self) -> int:
        '''Gets the signature.'''
        ...
    
    @property
    def key(self) -> int:
        '''Gets the layer resource key.'''
        ...
    
    @property
    def length(self) -> int:
        '''Gets the layer resource length in bytes.'''
        ...
    
    @property
    def psd_version(self) -> int:
        ...
    
    @classmethod
    @property
    def RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @classmethod
    @property
    def PSB_RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @property
    def fill_opacity(self) -> byte:
        ...
    
    @fill_opacity.setter
    def fill_opacity(self, value : byte):
        ...
    
    @classmethod
    @property
    def TYPE_TOOL_KEY(cls) -> int:
        ...
    
    ...

class KnkoResource(BooleanResource):
    '''Class KnkoResource.
    This resource contains information about blending of clipped element.'''
    
    def save(self, stream_container : aspose.psd.StreamContainer, psd_version : int):
        '''Saves the specified stream container.
        
        :param stream_container: The stream container.
        :param psd_version: The PSD version.'''
        ...
    
    @property
    def signature(self) -> int:
        '''Gets the signature.'''
        ...
    
    @property
    def key(self) -> int:
        '''Gets the layer resource key.'''
        ...
    
    @property
    def length(self) -> int:
        '''Gets the layer resource length in bytes.'''
        ...
    
    @property
    def psd_version(self) -> int:
        ...
    
    @classmethod
    @property
    def RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @classmethod
    @property
    def PSB_RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @property
    def knockout(self) -> bool:
        '''Gets a value indicating whether [blend interior elements].'''
        ...
    
    @knockout.setter
    def knockout(self, value : bool):
        '''Sets a value indicating whether [blend interior elements].'''
        ...
    
    @classmethod
    @property
    def TYPE_TOOL_KEY(cls) -> int:
        ...
    
    ...

class LayerSectionResource(aspose.psd.fileformats.psd.layers.LayerResource):
    '''The layer section resource.'''
    
    def save(self, stream_container : aspose.psd.StreamContainer, psd_version : int):
        '''Saves the resource to the specified stream container.
        
        :param stream_container: The stream container to save to.
        :param psd_version: The PSD version.'''
        ...
    
    @property
    def signature(self) -> int:
        '''Gets the layer resource signature.'''
        ...
    
    @property
    def key(self) -> int:
        '''Gets the layer resource key.'''
        ...
    
    @property
    def length(self) -> int:
        '''Gets the layer resource length in bytes.'''
        ...
    
    @property
    def psd_version(self) -> int:
        ...
    
    @classmethod
    @property
    def RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @classmethod
    @property
    def PSB_RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @property
    def blend_mode_key(self) -> aspose.psd.fileformats.core.blending.BlendMode:
        ...
    
    @blend_mode_key.setter
    def blend_mode_key(self, value : aspose.psd.fileformats.core.blending.BlendMode):
        ...
    
    @property
    def section_type(self) -> aspose.psd.fileformats.psd.layers.layerresources.LayerSectionType:
        ...
    
    @section_type.setter
    def section_type(self, value : aspose.psd.fileformats.psd.layers.layerresources.LayerSectionType):
        ...
    
    @property
    def subtype(self) -> aspose.psd.fileformats.psd.layers.layerresources.LayerSectionSubtype:
        '''Gets the subtype.'''
        ...
    
    @subtype.setter
    def subtype(self, value : aspose.psd.fileformats.psd.layers.layerresources.LayerSectionSubtype):
        '''Sets the subtype.'''
        ...
    
    @classmethod
    @property
    def TYPE_TOOL_KEY(cls) -> int:
        ...
    
    ...

class LclrResource(aspose.psd.fileformats.psd.layers.LayerResource):
    '''Class LclrResource.
    This resource contains information about color of layer in layers' list is PS. It's only'''
    
    def save(self, stream_container : aspose.psd.StreamContainer, psd_version : int):
        '''Saves the resource to the specified stream container.
        
        :param stream_container: The stream container to save to.
        :param psd_version: The PSD version.'''
        ...
    
    @property
    def signature(self) -> int:
        '''Gets the signature.'''
        ...
    
    @property
    def key(self) -> int:
        '''Gets the layer resource key.'''
        ...
    
    @property
    def length(self) -> int:
        '''Gets the layer resource length in bytes.'''
        ...
    
    @property
    def psd_version(self) -> int:
        ...
    
    @classmethod
    @property
    def RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @classmethod
    @property
    def PSB_RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @property
    def color(self) -> aspose.psd.fileformats.psd.layers.layerresources.SheetColorHighlightEnum:
        '''Gets the color of layer.'''
        ...
    
    @color.setter
    def color(self, value : aspose.psd.fileformats.psd.layers.layerresources.SheetColorHighlightEnum):
        '''Sets the color of layer.'''
        ...
    
    @classmethod
    @property
    def TYPE_TOOL_KEY(cls) -> int:
        ...
    
    ...

class LevelChannel:
    '''Class for working with channels in Levels Adjustment Layer'''
    
    @property
    def input_shadow_level(self) -> int:
        ...
    
    @input_shadow_level.setter
    def input_shadow_level(self, value : int):
        ...
    
    @property
    def input_highlight_level(self) -> int:
        ...
    
    @input_highlight_level.setter
    def input_highlight_level(self, value : int):
        ...
    
    @property
    def input_midtone_level(self) -> float:
        ...
    
    @input_midtone_level.setter
    def input_midtone_level(self, value : float):
        ...
    
    @property
    def output_shadow_level(self) -> int:
        ...
    
    @output_shadow_level.setter
    def output_shadow_level(self, value : int):
        ...
    
    @property
    def output_highlight_level(self) -> int:
        ...
    
    @output_highlight_level.setter
    def output_highlight_level(self, value : int):
        ...
    
    ...

class LevlResource(AdjustmentLayerResource):
    '''Class LevlResource. Resource of Exposure Adjustment Layer'''
    
    def save(self, stream_container : aspose.psd.StreamContainer, psd_version : int):
        '''Saves the resource to the specified stream container.
        
        :param stream_container: The stream container to save to.
        :param psd_version: The PSD version.'''
        ...
    
    def get_channel(self, channel_index : int) -> aspose.psd.fileformats.psd.layers.layerresources.LevelChannel:
        '''Gets the channel.
        
        :param channel_index: Index of the channel.
        :returns: Level Data of Channel'''
        ...
    
    @property
    def signature(self) -> int:
        '''Gets the signature.'''
        ...
    
    @property
    def key(self) -> int:
        '''Gets the layer resource key.'''
        ...
    
    @property
    def length(self) -> int:
        '''Gets the layer resource length in bytes.'''
        ...
    
    @property
    def psd_version(self) -> int:
        ...
    
    @classmethod
    @property
    def RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @classmethod
    @property
    def PSB_RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @property
    def version(self) -> int:
        '''Gets the version. Default is 2'''
        ...
    
    @classmethod
    @property
    def TYPE_TOOL_KEY(cls) -> int:
        ...
    
    ...

class Lfx2Resource(aspose.psd.fileformats.psd.layers.LayerResource):
    '''Lfx2 resource (effects resource)'''
    
    def save(self, stream_container : aspose.psd.StreamContainer, psd_version : int):
        '''Saves the resource to the specified stream container.
        
        :param stream_container: The stream container to save to.
        :param psd_version: The PSD version.'''
        ...
    
    @property
    def signature(self) -> int:
        '''Gets the layer resource signature.'''
        ...
    
    @property
    def key(self) -> int:
        '''Gets the layer resource key.'''
        ...
    
    @property
    def length(self) -> int:
        '''Gets the layer resource length in bytes.'''
        ...
    
    @property
    def psd_version(self) -> int:
        ...
    
    @classmethod
    @property
    def RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @classmethod
    @property
    def PSB_RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @property
    def descriptor_version(self) -> int:
        ...
    
    @classmethod
    @property
    def TYPE_TOOL_KEY(cls) -> int:
        ...
    
    ...

class LiFdDataSource(LinkDataSource):
    '''Defines the liFD data source class in PSD File that contains information about an embedded file.
    This is part of PSD File Format Manipulation API that helps to modify Adobe® Photoshop® files'''
    
    @property
    def type(self) -> aspose.psd.fileformats.psd.layers.layerresources.LinkDataSourceType:
        '''Gets the Adobe® Photoshop® global link data source type that can be one of the following or none:
        The embedded linked file liFD that corresponds to the PSD Lnk2Resource
        The external linked file liFE that corresponds to the PSD LnkeResource
        The linked file alias liFA'''
        ...
    
    @property
    def unique_id(self) -> Guid:
        ...
    
    @property
    def version(self) -> int:
        '''Gets the version of the data source in the PSD LnkE / Lnk2 resource.'''
        ...
    
    @property
    def original_file_name(self) -> str:
        ...
    
    @property
    def file_type(self) -> str:
        ...
    
    @file_type.setter
    def file_type(self, value : str):
        ...
    
    @property
    def file_creator(self) -> str:
        ...
    
    @file_creator.setter
    def file_creator(self, value : str):
        ...
    
    @property
    def child_doc_id(self) -> str:
        ...
    
    @child_doc_id.setter
    def child_doc_id(self, value : str):
        ...
    
    @property
    def asset_mod_time(self) -> float:
        ...
    
    @asset_mod_time.setter
    def asset_mod_time(self, value : float):
        ...
    
    @property
    def asset_locked_state(self) -> bool:
        ...
    
    @asset_locked_state.setter
    def asset_locked_state(self, value : bool):
        ...
    
    @property
    def is_library_link(self) -> bool:
        ...
    
    @property
    def length(self) -> int:
        '''Gets the link data source length in bytes.'''
        ...
    
    @property
    def comp_id(self) -> int:
        ...
    
    @comp_id.setter
    def comp_id(self, value : int):
        ...
    
    @property
    def original_comp_id(self) -> int:
        ...
    
    @property
    def has_file_open_descriptor(self) -> bool:
        ...
    
    @has_file_open_descriptor.setter
    def has_file_open_descriptor(self, value : bool):
        ...
    
    @property
    def data(self) -> bytes:
        '''Gets the embedded smart object data in PSD file.'''
        ...
    
    @data.setter
    def data(self, value : bytes):
        '''Sets the embedded smart object data in PSD file.'''
        ...
    
    ...

class LiFeDataSource(LinkDataSource):
    '''Defines the LnkeDataSource class that contains information about external linked file.
    This is part of PSD File Format Manipulation API that helps to modify Adobe® Photoshop® files'''
    
    @property
    def type(self) -> aspose.psd.fileformats.psd.layers.layerresources.LinkDataSourceType:
        '''Gets the Adobe® Photoshop® global link data source type that can be one of the following or none:
        The embedded linked file liFD that corresponds to the PSD Lnk2Resource
        The external linked file liFE that corresponds to the PSD LnkeResource
        The linked file alias liFA'''
        ...
    
    @property
    def unique_id(self) -> Guid:
        ...
    
    @property
    def version(self) -> int:
        '''Gets the version of the data source in the PSD LnkE / Lnk2 resource.'''
        ...
    
    @property
    def original_file_name(self) -> str:
        ...
    
    @property
    def file_type(self) -> str:
        ...
    
    @file_type.setter
    def file_type(self, value : str):
        ...
    
    @property
    def file_creator(self) -> str:
        ...
    
    @file_creator.setter
    def file_creator(self, value : str):
        ...
    
    @property
    def child_doc_id(self) -> str:
        ...
    
    @child_doc_id.setter
    def child_doc_id(self, value : str):
        ...
    
    @property
    def asset_mod_time(self) -> float:
        ...
    
    @asset_mod_time.setter
    def asset_mod_time(self, value : float):
        ...
    
    @property
    def asset_locked_state(self) -> bool:
        ...
    
    @asset_locked_state.setter
    def asset_locked_state(self, value : bool):
        ...
    
    @property
    def is_library_link(self) -> bool:
        ...
    
    @property
    def length(self) -> int:
        '''Gets the link data source length in bytes.'''
        ...
    
    @property
    def comp_id(self) -> int:
        ...
    
    @comp_id.setter
    def comp_id(self, value : int):
        ...
    
    @property
    def original_comp_id(self) -> int:
        ...
    
    @property
    def has_file_open_descriptor(self) -> bool:
        ...
    
    @has_file_open_descriptor.setter
    def has_file_open_descriptor(self, value : bool):
        ...
    
    @property
    def date(self) -> DateTime:
        '''Gets the last write date and time of the external file in the LiFE data source of the PSD LnkE resource.'''
        ...
    
    @date.setter
    def date(self, value : DateTime):
        '''Sets the last write date and time of the external file in the LiFE data source of the PSD LnkE resource.'''
        ...
    
    @property
    def file_size(self) -> int:
        ...
    
    @file_size.setter
    def file_size(self, value : int):
        ...
    
    @property
    def file_name(self) -> str:
        ...
    
    @file_name.setter
    def file_name(self, value : str):
        ...
    
    @property
    def full_path(self) -> str:
        ...
    
    @full_path.setter
    def full_path(self, value : str):
        ...
    
    @property
    def relative_path(self) -> str:
        ...
    
    @relative_path.setter
    def relative_path(self, value : str):
        ...
    
    @property
    def element_ref(self) -> str:
        ...
    
    @element_ref.setter
    def element_ref(self, value : str):
        ...
    
    @property
    def element_name(self) -> str:
        ...
    
    @element_name.setter
    def element_name(self, value : str):
        ...
    
    @property
    def adobe_stock_id(self) -> str:
        ...
    
    @adobe_stock_id.setter
    def adobe_stock_id(self, value : str):
        ...
    
    @property
    def adobe_stock_license_state(self) -> str:
        ...
    
    ...

class LinkDataSource:
    '''Defines the LinkDataSource class that contains information about a linked file or an asset in the PSD file.'''
    
    @property
    def type(self) -> aspose.psd.fileformats.psd.layers.layerresources.LinkDataSourceType:
        '''Gets the Adobe® Photoshop® global link data source type that can be one of the following or none:
        The embedded linked file liFD that corresponds to the PSD Lnk2Resource
        The external linked file liFE that corresponds to the PSD LnkeResource
        The linked file alias liFA'''
        ...
    
    @property
    def unique_id(self) -> Guid:
        ...
    
    @property
    def version(self) -> int:
        '''Gets the version of the data source in the PSD LnkE / Lnk2 resource.'''
        ...
    
    @property
    def original_file_name(self) -> str:
        ...
    
    @property
    def file_type(self) -> str:
        ...
    
    @file_type.setter
    def file_type(self, value : str):
        ...
    
    @property
    def file_creator(self) -> str:
        ...
    
    @file_creator.setter
    def file_creator(self, value : str):
        ...
    
    @property
    def child_doc_id(self) -> str:
        ...
    
    @child_doc_id.setter
    def child_doc_id(self, value : str):
        ...
    
    @property
    def asset_mod_time(self) -> float:
        ...
    
    @asset_mod_time.setter
    def asset_mod_time(self, value : float):
        ...
    
    @property
    def asset_locked_state(self) -> bool:
        ...
    
    @asset_locked_state.setter
    def asset_locked_state(self, value : bool):
        ...
    
    @property
    def is_library_link(self) -> bool:
        ...
    
    @property
    def length(self) -> int:
        '''Gets the link data source length in bytes.'''
        ...
    
    @property
    def comp_id(self) -> int:
        ...
    
    @comp_id.setter
    def comp_id(self, value : int):
        ...
    
    @property
    def original_comp_id(self) -> int:
        ...
    
    @property
    def has_file_open_descriptor(self) -> bool:
        ...
    
    @has_file_open_descriptor.setter
    def has_file_open_descriptor(self, value : bool):
        ...
    
    ...

class LinkResource(aspose.psd.fileformats.psd.layers.LayerResource):
    '''Defines the LinkResource class that contains information about linked or embedded files in the PSD format image.
    The link resource may contain several :py:class:`aspose.psd.fileformats.psd.layers.layerresources.LinkDataSource` instances which can be accessed by indexers in any derived class.'''
    
    def save(self, stream_container : aspose.psd.StreamContainer, psd_version : int):
        '''Saves the resource block data.
        
        :param stream_container: The stream container to save to.
        :param psd_version: The PSD version.'''
        ...
    
    @property
    def signature(self) -> int:
        '''Gets the PSD global link resource signature.'''
        ...
    
    @property
    def key(self) -> int:
        '''Gets the layer resource key.'''
        ...
    
    @property
    def length(self) -> int:
        '''Gets the PSD global link resource length in bytes.'''
        ...
    
    @property
    def psd_version(self) -> int:
        ...
    
    @classmethod
    @property
    def RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @classmethod
    @property
    def PSB_RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @property
    def is_empty(self) -> bool:
        ...
    
    @property
    def data_source_count(self) -> int:
        ...
    
    ...

class LmskResource(aspose.psd.fileformats.psd.layers.LayerResource):
    '''The LMsk resource.'''
    
    def save(self, stream_container : aspose.psd.StreamContainer, psd_version : int):
        '''Saves the resource to the specified stream container.
        
        :param stream_container: The stream container to save to.
        :param psd_version: The PSD version.'''
        ...
    
    @property
    def signature(self) -> int:
        '''Gets the signature.'''
        ...
    
    @property
    def key(self) -> int:
        '''Gets the layer resource key.'''
        ...
    
    @property
    def length(self) -> int:
        '''Gets the layer resource length in bytes.'''
        ...
    
    @property
    def psd_version(self) -> int:
        ...
    
    @classmethod
    @property
    def RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @classmethod
    @property
    def PSB_RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @property
    def color_space(self) -> aspose.psd.fileformats.psd.resources.enums.ColorSpace:
        ...
    
    @color_space.setter
    def color_space(self, value : aspose.psd.fileformats.psd.resources.enums.ColorSpace):
        ...
    
    @property
    def color_component1(self) -> int:
        ...
    
    @color_component1.setter
    def color_component1(self, value : int):
        ...
    
    @property
    def color_component2(self) -> int:
        ...
    
    @color_component2.setter
    def color_component2(self, value : int):
        ...
    
    @property
    def color_component3(self) -> int:
        ...
    
    @color_component3.setter
    def color_component3(self, value : int):
        ...
    
    @property
    def color_component4(self) -> int:
        ...
    
    @color_component4.setter
    def color_component4(self, value : int):
        ...
    
    @property
    def opacity(self) -> int:
        '''Gets the opacity.'''
        ...
    
    @opacity.setter
    def opacity(self, value : int):
        '''Gets the opacity.'''
        ...
    
    @property
    def flag(self) -> byte:
        '''Gets the flag.'''
        ...
    
    @classmethod
    @property
    def TYPE_TOOL_KEY(cls) -> int:
        ...
    
    ...

class Lnk2Resource(LinkResource):
    '''Defines the class which contains information about embedded files in the PSD format image.
    The link resource may contain several :py:class:`aspose.psd.fileformats.psd.layers.layerresources.LiFdDataSource` instances which can be accessed by the indexer.'''
    
    def save(self, stream_container : aspose.psd.StreamContainer, psd_version : int):
        '''Saves the resource block data.
        
        :param stream_container: The stream container to save to.
        :param psd_version: The PSD version.'''
        ...
    
    @property
    def signature(self) -> int:
        '''Gets the PSD global link resource signature.'''
        ...
    
    @property
    def key(self) -> int:
        '''Gets the layer resource key.'''
        ...
    
    @property
    def length(self) -> int:
        '''Gets the PSD global link resource length in bytes.'''
        ...
    
    @property
    def psd_version(self) -> int:
        ...
    
    @classmethod
    @property
    def RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @classmethod
    @property
    def PSB_RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @property
    def is_empty(self) -> bool:
        ...
    
    @property
    def data_source_count(self) -> int:
        ...
    
    @classmethod
    @property
    def TYPE_TOOL_KEY(cls) -> int:
        ...
    
    def __getitem__(self, key : int) -> aspose.psd.fileformats.psd.layers.layerresources.LiFdDataSource:
        '''Gets the :py:class:`aspose.psd.fileformats.psd.layers.layerresources.LiFdDataSource` at the specified index.'''
        ...
    
    ...

class Lnk3Resource(Lnk2Resource):
    '''Defines the class which contains information about an embedded file in the PSD format 32 bit per channel image.
    The link resource may contain several :py:class:`aspose.psd.fileformats.psd.layers.layerresources.LiFdDataSource` instances which can be accessed by indexer.'''
    
    def save(self, stream_container : aspose.psd.StreamContainer, psd_version : int):
        '''Saves the resource block data.
        
        :param stream_container: The stream container to save to.
        :param psd_version: The PSD version.'''
        ...
    
    @property
    def signature(self) -> int:
        '''Gets the PSD global link resource signature.'''
        ...
    
    @property
    def key(self) -> int:
        '''Gets the layer resource key.'''
        ...
    
    @property
    def length(self) -> int:
        '''Gets the PSD global link resource length in bytes.'''
        ...
    
    @property
    def psd_version(self) -> int:
        ...
    
    @classmethod
    @property
    def RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @classmethod
    @property
    def PSB_RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @property
    def is_empty(self) -> bool:
        ...
    
    @property
    def data_source_count(self) -> int:
        ...
    
    @classmethod
    @property
    def TYPE_TOOL_KEY(cls) -> int:
        ...
    
    def __getitem__(self, key : int) -> aspose.psd.fileformats.psd.layers.layerresources.LiFdDataSource:
        ...
    
    ...

class LnkeResource(LinkResource):
    '''Defines the LnkeResource class that contains information about external linked files or assets in the PSD format image.
    The link resource may contain several :py:class:`aspose.psd.fileformats.psd.layers.layerresources.LiFeDataSource` instances which can be accessed by indexer.
    This is a part of PSD File Format Manipulation API that helps to modify Adobe® Photoshop® files programmatically'''
    
    def save(self, stream_container : aspose.psd.StreamContainer, psd_version : int):
        '''Saves the resource block data.
        
        :param stream_container: The stream container to save to.
        :param psd_version: The PSD version.'''
        ...
    
    @property
    def signature(self) -> int:
        '''Gets the PSD global link resource signature.'''
        ...
    
    @property
    def key(self) -> int:
        '''Gets the Adobe® Photoshop® global resource key.'''
        ...
    
    @property
    def length(self) -> int:
        '''Gets the PSD global link resource length in bytes.'''
        ...
    
    @property
    def psd_version(self) -> int:
        ...
    
    @classmethod
    @property
    def RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @classmethod
    @property
    def PSB_RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @property
    def is_empty(self) -> bool:
        ...
    
    @property
    def data_source_count(self) -> int:
        ...
    
    @classmethod
    @property
    def TYPE_TOOL_KEY(cls) -> int:
        ...
    
    def __getitem__(self, key : int) -> aspose.psd.fileformats.psd.layers.layerresources.LiFeDataSource:
        '''Gets the :py:class:`aspose.psd.fileformats.psd.layers.layerresources.LiFeDataSource` at the specified index.'''
        ...
    
    ...

class LnsrResource(aspose.psd.fileformats.psd.layers.LayerResource):
    '''Class lnsrResource.'''
    
    def save(self, stream_container : aspose.psd.StreamContainer, psd_version : int):
        '''Saves the specified stream container.
        
        :param stream_container: The stream container.
        :param psd_version: The PSD version.'''
        ...
    
    @property
    def signature(self) -> int:
        '''Gets the signature.'''
        ...
    
    @property
    def key(self) -> int:
        '''Gets the layer resource key.'''
        ...
    
    @property
    def length(self) -> int:
        '''Gets the layer resource length in bytes.'''
        ...
    
    @property
    def psd_version(self) -> int:
        ...
    
    @classmethod
    @property
    def RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @classmethod
    @property
    def PSB_RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @property
    def data(self) -> bytes:
        '''Gets the raw data.'''
        ...
    
    @property
    def value(self) -> aspose.psd.fileformats.psd.layers.layerresources.LnsrResourceType:
        '''Gets the value as LnsrResourceType if corresponding enum is described.
        Otherwise return Unknown'''
        ...
    
    @classmethod
    @property
    def TYPE_TOOL_KEY(cls) -> int:
        ...
    
    ...

class Lr16Resource(LrXxResource):
    '''The lr16 resource.'''
    
    def save(self, stream_container : aspose.psd.StreamContainer, psd_version : int):
        '''Saves the layer record.
        
        :param stream_container: The stream container.
        :param psd_version: The psd version.'''
        ...
    
    @property
    def signature(self) -> int:
        '''Gets the signature.'''
        ...
    
    @property
    def key(self) -> int:
        '''Gets the layer resource key.'''
        ...
    
    @property
    def length(self) -> int:
        '''Gets the resource length for the PSD header version of the image.'''
        ...
    
    @property
    def psd_version(self) -> int:
        ...
    
    @classmethod
    @property
    def RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @classmethod
    @property
    def PSB_RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @property
    def layers(self) -> List[aspose.psd.fileformats.psd.layers.Layer]:
        '''Gets the layers.'''
        ...
    
    @layers.setter
    def layers(self, value : List[aspose.psd.fileformats.psd.layers.Layer]):
        '''Sets the layers.'''
        ...
    
    @classmethod
    @property
    def TYPE_TOOL_KEY(cls) -> int:
        ...
    
    ...

class Lr32Resource(LrXxResource):
    '''The lr32 resource.'''
    
    def save(self, stream_container : aspose.psd.StreamContainer, psd_version : int):
        '''Saves the layer record.
        
        :param stream_container: The stream container.
        :param psd_version: The psd version.'''
        ...
    
    @property
    def signature(self) -> int:
        '''Gets the signature.'''
        ...
    
    @property
    def key(self) -> int:
        '''Gets the layer resource key.'''
        ...
    
    @property
    def length(self) -> int:
        '''Gets the resource length for the PSD header version of the image.'''
        ...
    
    @property
    def psd_version(self) -> int:
        ...
    
    @classmethod
    @property
    def RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @classmethod
    @property
    def PSB_RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @property
    def layers(self) -> List[aspose.psd.fileformats.psd.layers.Layer]:
        '''Gets the layers.'''
        ...
    
    @layers.setter
    def layers(self, value : List[aspose.psd.fileformats.psd.layers.Layer]):
        '''Sets the layers.'''
        ...
    
    @classmethod
    @property
    def TYPE_TOOL_KEY(cls) -> int:
        ...
    
    ...

class LrXxResource(aspose.psd.fileformats.psd.layers.LayerResource):
    '''The lrXX resource.'''
    
    def save(self, stream_container : aspose.psd.StreamContainer, psd_version : int):
        '''Saves the layer record.
        
        :param stream_container: The stream container.
        :param psd_version: The psd version.'''
        ...
    
    @property
    def signature(self) -> int:
        '''Gets the signature.'''
        ...
    
    @property
    def key(self) -> int:
        '''Gets the layer resource key.'''
        ...
    
    @property
    def length(self) -> int:
        '''Gets the resource length for the PSD header version of the image.'''
        ...
    
    @property
    def psd_version(self) -> int:
        ...
    
    @classmethod
    @property
    def RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @classmethod
    @property
    def PSB_RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @property
    def layers(self) -> List[aspose.psd.fileformats.psd.layers.Layer]:
        '''Gets the layers.'''
        ...
    
    @layers.setter
    def layers(self, value : List[aspose.psd.fileformats.psd.layers.Layer]):
        '''Sets the layers.'''
        ...
    
    ...

class LspfResource(aspose.psd.fileformats.psd.layers.LayerResource):
    '''Layer protected settings'''
    
    def save(self, stream_container : aspose.psd.StreamContainer, psd_version : int):
        '''Saves the resource to the specified stream container.
        
        :param stream_container: The stream container to save to.
        :param psd_version: The PSD version.'''
        ...
    
    @property
    def signature(self) -> int:
        '''Gets the layer resource signature.'''
        ...
    
    @property
    def key(self) -> int:
        '''Gets the layer resource key.'''
        ...
    
    @property
    def length(self) -> int:
        '''Gets the layer resource length in bytes.'''
        ...
    
    @property
    def psd_version(self) -> int:
        ...
    
    @classmethod
    @property
    def RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @classmethod
    @property
    def PSB_RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @property
    def is_transparency_protected(self) -> bool:
        ...
    
    @is_transparency_protected.setter
    def is_transparency_protected(self, value : bool):
        ...
    
    @property
    def is_composite_protected(self) -> bool:
        ...
    
    @is_composite_protected.setter
    def is_composite_protected(self, value : bool):
        ...
    
    @property
    def is_position_protected(self) -> bool:
        ...
    
    @is_position_protected.setter
    def is_position_protected(self, value : bool):
        ...
    
    @property
    def lock_type(self) -> aspose.psd.fileformats.psd.layers.layerresources.LayerLockType:
        ...
    
    @lock_type.setter
    def lock_type(self, value : aspose.psd.fileformats.psd.layers.layerresources.LayerLockType):
        ...
    
    @classmethod
    @property
    def TYPE_TOOL_KEY(cls) -> int:
        ...
    
    ...

class LuniResource(aspose.psd.fileformats.psd.layers.LayerResource):
    '''Layer name resource'''
    
    def save(self, stream_container : aspose.psd.StreamContainer, psd_version : int):
        '''Saves the specified stream container.
        
        :param stream_container: The stream container.
        :param psd_version: The PSD version.'''
        ...
    
    @property
    def signature(self) -> int:
        '''Gets the layer resource signature.'''
        ...
    
    @property
    def key(self) -> int:
        '''Gets the layer resource key.'''
        ...
    
    @property
    def length(self) -> int:
        '''Gets the layer resource length in bytes.'''
        ...
    
    @property
    def psd_version(self) -> int:
        ...
    
    @classmethod
    @property
    def RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @classmethod
    @property
    def PSB_RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @property
    def name(self) -> str:
        '''Gets the name.'''
        ...
    
    @name.setter
    def name(self, value : str):
        '''Sets the name.'''
        ...
    
    @classmethod
    @property
    def TYPE_TOOL_KEY(cls) -> int:
        ...
    
    ...

class LyidResource(aspose.psd.fileformats.psd.layers.LayerResource):
    '''Class LyidResource.'''
    
    def save(self, stream_container : aspose.psd.StreamContainer, psd_version : int):
        '''Saves to the specified stream container.
        
        :param stream_container: The stream container.
        :param psd_version: The PSD version.'''
        ...
    
    @property
    def signature(self) -> int:
        '''Gets the signature.'''
        ...
    
    @property
    def key(self) -> int:
        '''Gets the layer resource key.'''
        ...
    
    @property
    def length(self) -> int:
        '''Gets the layer resource length in bytes.'''
        ...
    
    @property
    def psd_version(self) -> int:
        ...
    
    @classmethod
    @property
    def RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @classmethod
    @property
    def PSB_RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @property
    def value(self) -> int:
        '''Gets the value.'''
        ...
    
    @classmethod
    @property
    def TYPE_TOOL_KEY(cls) -> int:
        ...
    
    ...

class MixrResource(AdjustmentLayerResource):
    '''Class MixrResource. Resource of Channel Mixer Adjustment Layer'''
    
    def save(self, stream_container : aspose.psd.StreamContainer, psd_version : int):
        '''Saves the resource to the specified stream container.
        
        :param stream_container: The stream container to save to.
        :param psd_version: The PSD version.'''
        ...
    
    def get_channel_info(self, channel_index : int) -> bytes:
        '''Gets the channel information raw data
        
        :param channel_index: Index of the channel.
        :returns: Raw byte array of channel info.'''
        ...
    
    def set_channel_info(self, channel_index : int, value : bytes):
        '''Sets the channel information.
        
        :param channel_index: Index of the channel.
        :param value: The value.'''
        ...
    
    @property
    def signature(self) -> int:
        '''Gets the signature.'''
        ...
    
    @property
    def key(self) -> int:
        '''Gets the layer resource key.'''
        ...
    
    @property
    def length(self) -> int:
        '''Gets the layer resource length in bytes.'''
        ...
    
    @property
    def psd_version(self) -> int:
        ...
    
    @classmethod
    @property
    def RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @classmethod
    @property
    def PSB_RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @property
    def version(self) -> int:
        '''Gets the version.'''
        ...
    
    @version.setter
    def version(self, value : int):
        '''Sets the version.'''
        ...
    
    @property
    def monochrome(self) -> bool:
        '''Gets a value indicating whether this :py:class:`aspose.psd.fileformats.psd.layers.layerresources.MixrResource` is monochrome.'''
        ...
    
    @monochrome.setter
    def monochrome(self, value : bool):
        '''Sets a value indicating whether this :py:class:`aspose.psd.fileformats.psd.layers.layerresources.MixrResource` is monochrome.'''
        ...
    
    @classmethod
    @property
    def TYPE_TOOL_KEY(cls) -> int:
        ...
    
    ...

class MlstResource(aspose.psd.fileformats.psd.layers.LayerResource):
    '''The mlst resource.
    This class, among other things, contains information about the position of the layer on the timeline.'''
    
    def save(self, stream_container : aspose.psd.StreamContainer, psd_version : int):
        '''Saves the specified stream container.
        
        :param stream_container: The stream container.
        :param psd_version: The PSD version.'''
        ...
    
    @property
    def signature(self) -> int:
        '''Gets the signature.'''
        ...
    
    @property
    def key(self) -> int:
        '''Gets the layer resource key.'''
        ...
    
    @property
    def length(self) -> int:
        '''Gets the layer resource length in bytes.'''
        ...
    
    @property
    def psd_version(self) -> int:
        ...
    
    @classmethod
    @property
    def RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @classmethod
    @property
    def PSB_RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @property
    def descriptor_version(self) -> int:
        ...
    
    @property
    def items(self) -> List[aspose.psd.fileformats.psd.layers.layerresources.OSTypeStructure]:
        '''Gets the structures.'''
        ...
    
    @classmethod
    @property
    def TYPE_TOOL_KEY(cls) -> int:
        ...
    
    ...

class NvrtResource(AdjustmentLayerResource):
    '''Class NvrtResource. Resource of Invert Adjustment Layer.'''
    
    def save(self, stream_container : aspose.psd.StreamContainer, psd_version : int):
        '''Saves the resource to the specified stream container.
        
        :param stream_container: The stream container to save to.
        :param psd_version: The PSD version.'''
        ...
    
    @property
    def signature(self) -> int:
        '''Gets the signature.'''
        ...
    
    @property
    def key(self) -> int:
        '''Gets the layer resource key.'''
        ...
    
    @property
    def length(self) -> int:
        '''Gets the layer resource length in bytes.'''
        ...
    
    @property
    def psd_version(self) -> int:
        ...
    
    @classmethod
    @property
    def RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @classmethod
    @property
    def PSB_RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @classmethod
    @property
    def TYPE_TOOL_KEY(cls) -> int:
        ...
    
    ...

class OSTypeStructure:
    '''Represents the OS type structure.'''
    
    def save(self, stream_container : aspose.psd.StreamContainer):
        '''Saves the structure to the specified stream container.
        
        :param stream_container: The stream container.'''
        ...
    
    def save_without_key_name(self, stream_container : aspose.psd.StreamContainer):
        '''Saves the structure to the specified stream container.
        
        :param stream_container: The stream container.'''
        ...
    
    def get_header_length(self) -> int:
        '''Gets the header length.
        
        :returns: The header length'''
        ...
    
    @property
    def key(self) -> int:
        '''Gets the structure key.'''
        ...
    
    @property
    def key_name(self) -> aspose.psd.fileformats.psd.layers.layerresources.ClassID:
        ...
    
    @key_name.setter
    def key_name(self, value : aspose.psd.fileformats.psd.layers.layerresources.ClassID):
        ...
    
    @property
    def length(self) -> int:
        '''Gets the :py:class:`aspose.psd.fileformats.psd.layers.layerresources.OSTypeStructure` length in bytes.'''
        ...
    
    ...

class OSTypeStructuresRegistry:
    '''Represents the :py:class:`aspose.psd.fileformats.psd.layers.layerresources.OSTypeStructure` resources registry.'''
    
    @staticmethod
    def get_first_supported_descriptor_by_type_name(descriptor_type_name : str) -> aspose.psd.fileformats.psd.layers.layerresources.IOSTypeStructureLoader:
        '''Gets the first supported descriptor by its type name.
        
        :param descriptor_type_name: The descriptor type name.
        :returns: The first found opener descriptor or null if not such descriptor is found.'''
        ...
    
    @staticmethod
    def get_first_supported_descriptor(stream : io.RawIOBase) -> aspose.psd.fileformats.psd.layers.layerresources.IOSTypeStructureLoader:
        '''Gets the first supported opener descriptor.
        
        :param stream: The stream.
        :returns: The layer resource loader descriptor or null if no loader descriptor supported for such stream.'''
        ...
    
    @staticmethod
    def load_resource_by_first_supported_descriptor(stream : io.RawIOBase) -> aspose.psd.fileformats.psd.layers.layerresources.OSTypeStructure:
        '''Loads :py:class:`aspose.psd.fileformats.psd.layers.layerresources.OSTypeStructure` using first found opener suitable for the specified ``stream``.
        
        :param stream: The stream.
        :returns: The loaded :py:class:`aspose.psd.fileformats.psd.layers.LayerResource` or null if no opener is found.'''
        ...
    
    @staticmethod
    def register_opener(opener_descriptor : aspose.psd.fileformats.psd.layers.layerresources.IOSTypeStructureLoader):
        '''Registers the opener.
        
        :param opener_descriptor: The opener descriptor to register.'''
        ...
    
    @staticmethod
    def unregister_opener(opener_descriptor : aspose.psd.fileformats.psd.layers.layerresources.IOSTypeStructureLoader):
        '''Unregisters the opener.
        
        :param opener_descriptor: The opener descriptor to unregister.'''
        ...
    
    @classmethod
    @property
    def registered_descriptors(cls) -> List[aspose.psd.fileformats.psd.layers.layerresources.IOSTypeStructureLoader]:
        ...
    
    ...

class PathShape(IPathShape):
    '''The figure from the knots of the Bezier curve.'''
    
    def get_items(self) -> List[aspose.psd.fileformats.core.vectorpaths.BezierKnotRecord]:
        '''Gets array of Bezier knots.
        
        :returns: Array of BezierKnotRecord'''
        ...
    
    def set_items(self, bezier_points : List[aspose.psd.fileformats.core.vectorpaths.BezierKnotRecord]):
        '''Assignes array of Bexier knots.
        
        :param bezier_points: Array of bezier knots'''
        ...
    
    def to_vector_path_records(self) -> Iterable[aspose.psd.fileformats.core.vectorpaths.VectorPathRecord]:
        '''Creates the :py:class:`aspose.psd.fileformats.core.vectorpaths.VectorPathRecord` records based on this instance.
        
        :returns: Returns one :py:class:`aspose.psd.fileformats.core.vectorpaths.LengthRecord` and :py:class:`aspose.psd.fileformats.core.vectorpaths.BezierKnotRecord` for each point in this instance.'''
        ...
    
    @property
    def is_closed(self) -> bool:
        ...
    
    @is_closed.setter
    def is_closed(self, value : bool):
        ...
    
    @property
    def path_operations(self) -> aspose.psd.fileformats.core.vectorpaths.PathOperations:
        ...
    
    @path_operations.setter
    def path_operations(self, value : aspose.psd.fileformats.core.vectorpaths.PathOperations):
        ...
    
    @property
    def shape_index(self) -> int:
        ...
    
    @shape_index.setter
    def shape_index(self, value : int):
        ...
    
    ...

class PattResource(aspose.psd.fileformats.psd.layers.LayerResource):
    '''Class PattResource. Resource with pattern data'''
    
    def save(self, stream_container : aspose.psd.StreamContainer, psd_version : int):
        '''Saves the resource block data.
        
        :param stream_container: The stream container to save to.
        :param psd_version: The PSD version.'''
        ...
    
    @property
    def signature(self) -> int:
        '''Gets the layer resource signature.'''
        ...
    
    @property
    def key(self) -> int:
        '''Gets the layer resource key.'''
        ...
    
    @property
    def length(self) -> int:
        '''Gets the layer resource length in bytes.'''
        ...
    
    @property
    def psd_version(self) -> int:
        ...
    
    @classmethod
    @property
    def RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @classmethod
    @property
    def PSB_RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @property
    def patterns(self) -> List[aspose.psd.fileformats.psd.layers.layerresources.PattResourceData]:
        '''Gets the patterns data;'''
        ...
    
    @patterns.setter
    def patterns(self, value : List[aspose.psd.fileformats.psd.layers.layerresources.PattResourceData]):
        '''Sets the patterns data;'''
        ...
    
    @classmethod
    @property
    def TYPE_TOOL_KEY(cls) -> int:
        ...
    
    @classmethod
    @property
    def TYPE_TOOL_KEY2(cls) -> int:
        ...
    
    @classmethod
    @property
    def TYPE_TOOL_KEY3(cls) -> int:
        ...
    
    ...

class PattResourceData:
    '''The class to store the pattern data for :py:class:`aspose.psd.fileformats.psd.layers.layerresources.PattResource` resource.'''
    
    def save(self, stream_container : aspose.psd.StreamContainer):
        '''Saves the pattern data.
        
        :param stream_container: The stream container to save to.'''
        ...
    
    def set_pattern(self, pixels : List[int], bounds : aspose.psd.Rectangle):
        '''Sets the pattern.
        
        :param pixels: The pixels.
        :param bounds: The bounds.'''
        ...
    
    @property
    def version(self) -> int:
        '''Gets the version.'''
        ...
    
    @property
    def image_mode(self) -> aspose.psd.fileformats.psd.ColorModes:
        ...
    
    @property
    def width(self) -> int:
        '''Gets the width.'''
        ...
    
    @property
    def height(self) -> int:
        '''Gets the height.'''
        ...
    
    @property
    def name(self) -> str:
        '''Gets the name.'''
        ...
    
    @name.setter
    def name(self, value : str):
        '''Sets the name.'''
        ...
    
    @property
    def pattern_id(self) -> str:
        ...
    
    @pattern_id.setter
    def pattern_id(self, value : str):
        ...
    
    @property
    def pattern_data(self) -> List[int]:
        ...
    
    @property
    def length(self) -> int:
        '''Gets the length of the pattern.'''
        ...
    
    ...

class PhflResource(AdjustmentLayerResource):
    '''Class PhflResource. Resource of Exposure Adjustment Layer
    2 Version ( = 3 ) or ( = 2 )
    12 4 bytes each for XYZ color(Only in Version 3)
    10 2 bytes color space followed by 4 * 2 bytes color component(Only in Version 2)
    4 Density
    1 Preserve Luminosity'''
    
    def save(self, stream_container : aspose.psd.StreamContainer, psd_version : int):
        '''Saves the resource to the specified stream container.
        
        :param stream_container: The stream container to save to.
        :param psd_version: The PSD version.'''
        ...
    
    def get_rgb_color(self) -> aspose.psd.Color:
        '''Gets the color of the RGB.
        
        :returns: The RGB Color'''
        ...
    
    def set_rgb_color(self, color : aspose.psd.Color):
        '''Sets the RGB color.
        
        :param color: The RGB color.'''
        ...
    
    @property
    def signature(self) -> int:
        '''Gets the signature.'''
        ...
    
    @property
    def key(self) -> int:
        '''Gets the layer resource key.'''
        ...
    
    @property
    def length(self) -> int:
        '''Gets the layer resource length in bytes.'''
        ...
    
    @property
    def psd_version(self) -> int:
        ...
    
    @classmethod
    @property
    def RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @classmethod
    @property
    def PSB_RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @property
    def density(self) -> int:
        '''Gets the density.'''
        ...
    
    @density.setter
    def density(self, value : int):
        '''Sets the density.'''
        ...
    
    @property
    def preserve_luminosity(self) -> bool:
        ...
    
    @preserve_luminosity.setter
    def preserve_luminosity(self, value : bool):
        ...
    
    @property
    def version(self) -> int:
        '''Gets the version. Default is 2 or 3'''
        ...
    
    @classmethod
    @property
    def TYPE_TOOL_KEY(cls) -> int:
        ...
    
    ...

class PhflResourceVersion2(PhflResource):
    '''Class PhflResource. Resource of Exposure Adjustment Layer
    2 Version ( = 3 ) or ( = 2 )
    12 4 bytes each for XYZ color(Only in Version 3)
    10 2 bytes color space followed by 4 * 2 bytes color component(Only in Version 2)
    4 Density
    1 Preserve Luminosity'''
    
    def save(self, stream_container : aspose.psd.StreamContainer, psd_version : int):
        '''Saves the resource to the specified stream container.
        
        :param stream_container: The stream container to save to.
        :param psd_version: The PSD version.'''
        ...
    
    def get_rgb_color(self) -> aspose.psd.Color:
        '''Gets the color.
        
        :returns: The RGB color'''
        ...
    
    def set_rgb_color(self, color : aspose.psd.Color):
        '''Sets the RGB color.
        
        :param color: The color.'''
        ...
    
    @property
    def signature(self) -> int:
        '''Gets the signature.'''
        ...
    
    @property
    def key(self) -> int:
        '''Gets the layer resource key.'''
        ...
    
    @property
    def length(self) -> int:
        '''Gets the layer resource length in bytes.'''
        ...
    
    @property
    def psd_version(self) -> int:
        ...
    
    @classmethod
    @property
    def RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @classmethod
    @property
    def PSB_RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @property
    def density(self) -> int:
        '''Gets the density.'''
        ...
    
    @density.setter
    def density(self, value : int):
        '''Sets the density.'''
        ...
    
    @property
    def preserve_luminosity(self) -> bool:
        ...
    
    @preserve_luminosity.setter
    def preserve_luminosity(self, value : bool):
        ...
    
    @property
    def version(self) -> int:
        '''Gets the version.'''
        ...
    
    @classmethod
    @property
    def TYPE_TOOL_KEY(cls) -> int:
        ...
    
    @property
    def color_space(self) -> int:
        ...
    
    @property
    def component_l(self) -> int:
        ...
    
    @component_l.setter
    def component_l(self, value : int):
        ...
    
    @property
    def component_a(self) -> int:
        ...
    
    @component_a.setter
    def component_a(self, value : int):
        ...
    
    @property
    def component_b(self) -> int:
        ...
    
    @component_b.setter
    def component_b(self, value : int):
        ...
    
    ...

class PhflResourceVersion3(PhflResource):
    '''Class PhflResource. Resource of Exposure Adjustment Layer
    2 Version ( = 3 ) or ( = 2 )
    12 4 bytes each for XYZ color(Only in Version 3)
    10 2 bytes color space followed by 4 * 2 bytes color component(Only in Version 2)
    4 Density
    1 Preserve Luminosity'''
    
    def save(self, stream_container : aspose.psd.StreamContainer, psd_version : int):
        '''Saves the resource to the specified stream container.
        
        :param stream_container: The stream container to save to.
        :param psd_version: The PSD version.'''
        ...
    
    def get_rgb_color(self) -> aspose.psd.Color:
        '''Gets the color.
        
        :returns: The RGB color'''
        ...
    
    def set_rgb_color(self, color : aspose.psd.Color):
        '''Sets the RGB color.
        
        :param color: The color.'''
        ...
    
    @property
    def signature(self) -> int:
        '''Gets the signature.'''
        ...
    
    @property
    def key(self) -> int:
        '''Gets the layer resource key.'''
        ...
    
    @property
    def length(self) -> int:
        '''Gets the layer resource length in bytes.'''
        ...
    
    @property
    def psd_version(self) -> int:
        ...
    
    @classmethod
    @property
    def RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @classmethod
    @property
    def PSB_RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @property
    def density(self) -> int:
        '''Gets the density.'''
        ...
    
    @density.setter
    def density(self, value : int):
        '''Sets the density.'''
        ...
    
    @property
    def preserve_luminosity(self) -> bool:
        ...
    
    @preserve_luminosity.setter
    def preserve_luminosity(self, value : bool):
        ...
    
    @property
    def version(self) -> int:
        '''Gets the version. Default is 2 or 3'''
        ...
    
    @classmethod
    @property
    def TYPE_TOOL_KEY(cls) -> int:
        ...
    
    @property
    def color_space(self) -> int:
        ...
    
    @property
    def color_x(self) -> float:
        ...
    
    @color_x.setter
    def color_x(self, value : float):
        ...
    
    @property
    def color_y(self) -> float:
        ...
    
    @color_y.setter
    def color_y(self, value : float):
        ...
    
    @property
    def color_z(self) -> float:
        ...
    
    @color_z.setter
    def color_z(self, value : float):
        ...
    
    ...

class PlLdResource(PlacedResource):
    '''Defines the PlLdResource class that contains information about a placed layer in the PSD file.
    Is is used to support smart object layers in the Adobe® Photoshop® images.
    It was replaced by SoLdResource in the Adobe® Photoshop® CS3'''
    
    def save(self, stream_container : aspose.psd.StreamContainer, psd_version : int):
        '''Saves the PlLD resource to the specified stream container.
        
        :param stream_container: The stream container to save to.
        :param psd_version: The PSD version.'''
        ...
    
    @property
    def signature(self) -> int:
        '''Gets the PlLd resource signature.'''
        ...
    
    @property
    def key(self) -> int:
        '''Gets the PlLd resource key.'''
        ...
    
    @property
    def length(self) -> int:
        '''Gets the PlLd resource length in bytes.'''
        ...
    
    @property
    def psd_version(self) -> int:
        ...
    
    @classmethod
    @property
    def RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @classmethod
    @property
    def PSB_RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @property
    def version(self) -> int:
        '''Gets the version of the placed layer in the PSD file, usually 3.'''
        ...
    
    @property
    def unique_id(self) -> Guid:
        ...
    
    @unique_id.setter
    def unique_id(self, value : Guid):
        ...
    
    @property
    def is_custom(self) -> bool:
        ...
    
    @is_custom.setter
    def is_custom(self, value : bool):
        ...
    
    @property
    def page_number(self) -> int:
        ...
    
    @page_number.setter
    def page_number(self, value : int):
        ...
    
    @property
    def total_pages(self) -> int:
        ...
    
    @total_pages.setter
    def total_pages(self, value : int):
        ...
    
    @property
    def anti_alias_policy(self) -> int:
        ...
    
    @anti_alias_policy.setter
    def anti_alias_policy(self, value : int):
        ...
    
    @property
    def placed_layer_type(self) -> aspose.psd.fileformats.psd.layers.layerresources.PlacedLayerType:
        ...
    
    @placed_layer_type.setter
    def placed_layer_type(self, value : aspose.psd.fileformats.psd.layers.layerresources.PlacedLayerType):
        ...
    
    @property
    def left(self) -> float:
        '''Gets the left location of the placed layer in the PSD file.'''
        ...
    
    @left.setter
    def left(self, value : float):
        '''Sets the left location of the placed layer in the PSD file.'''
        ...
    
    @property
    def top(self) -> float:
        '''Gets the top location of the placed layer in the PSD image.'''
        ...
    
    @top.setter
    def top(self, value : float):
        '''Sets the top location of the placed layer in the PSD image.'''
        ...
    
    @property
    def right(self) -> float:
        '''Gets the right location of the placed layer in the PSD file.'''
        ...
    
    @right.setter
    def right(self, value : float):
        '''Sets the right location of the placed layer in the PSD file.'''
        ...
    
    @property
    def bottom(self) -> float:
        '''Gets the bottom location of the placed layer in the PSD image.'''
        ...
    
    @bottom.setter
    def bottom(self, value : float):
        '''Sets the bottom location of the placed layer in the PSD image.'''
        ...
    
    @property
    def bounds(self) -> aspose.psd.Rectangle:
        '''Gets the bounds of the placed layer in the PSD file.'''
        ...
    
    @bounds.setter
    def bounds(self, value : aspose.psd.Rectangle):
        '''Sets the bounds of the placed layer in the PSD file.'''
        ...
    
    @property
    def transform_matrix(self) -> List[float]:
        ...
    
    @transform_matrix.setter
    def transform_matrix(self, value : List[float]):
        ...
    
    @property
    def horizontal_mesh_points(self) -> List[float]:
        ...
    
    @horizontal_mesh_points.setter
    def horizontal_mesh_points(self, value : List[float]):
        ...
    
    @property
    def vertical_mesh_points(self) -> List[float]:
        ...
    
    @vertical_mesh_points.setter
    def vertical_mesh_points(self, value : List[float]):
        ...
    
    @property
    def horizontal_mesh_point_unit(self) -> aspose.psd.fileformats.psd.layers.layerresources.typetoolinfostructures.UnitTypes:
        ...
    
    @horizontal_mesh_point_unit.setter
    def horizontal_mesh_point_unit(self, value : aspose.psd.fileformats.psd.layers.layerresources.typetoolinfostructures.UnitTypes):
        ...
    
    @property
    def vertical_mesh_point_unit(self) -> aspose.psd.fileformats.psd.layers.layerresources.typetoolinfostructures.UnitTypes:
        ...
    
    @vertical_mesh_point_unit.setter
    def vertical_mesh_point_unit(self, value : aspose.psd.fileformats.psd.layers.layerresources.typetoolinfostructures.UnitTypes):
        ...
    
    @property
    def value(self) -> float:
        '''Gets the warp value of the placed layer in the PSD image.'''
        ...
    
    @value.setter
    def value(self, value : float):
        '''Sets the warp value of the placed layer in the PSD image.'''
        ...
    
    @property
    def perspective(self) -> float:
        '''Gets the perspective value of the placed layer in the PSD file.'''
        ...
    
    @perspective.setter
    def perspective(self, value : float):
        '''Sets the perspective value of the placed layer in the PSD file.'''
        ...
    
    @property
    def perspective_other(self) -> float:
        ...
    
    @perspective_other.setter
    def perspective_other(self, value : float):
        ...
    
    @property
    def u_order(self) -> int:
        ...
    
    @u_order.setter
    def u_order(self, value : int):
        ...
    
    @property
    def v_order(self) -> int:
        ...
    
    @v_order.setter
    def v_order(self, value : int):
        ...
    
    @property
    def items(self) -> List[aspose.psd.fileformats.psd.layers.layerresources.OSTypeStructure]:
        '''Gets the warp items.'''
        ...
    
    @items.setter
    def items(self, value : List[aspose.psd.fileformats.psd.layers.layerresources.OSTypeStructure]):
        '''Sets the warp items.'''
        ...
    
    @classmethod
    @property
    def TYPE_TOOL_KEY(cls) -> int:
        ...
    
    ...

class PlacedResource(aspose.psd.fileformats.psd.layers.LayerResource):
    '''Defines the PlacedResource class that contains common information about a placed layer or a smart object layer in the PSD file.
    Is is used to support smart object layers in the Adobe® Photoshop® images.'''
    
    def save(self, stream_container : aspose.psd.StreamContainer, psd_version : int):
        '''Saves the resource to the specified stream container.
        
        :param stream_container: The stream container to save to.
        :param psd_version: The PSD version.'''
        ...
    
    @property
    def signature(self) -> int:
        '''Gets the Placed resource signature.'''
        ...
    
    @property
    def key(self) -> int:
        '''Gets the layer resource key.'''
        ...
    
    @property
    def length(self) -> int:
        '''Gets the layer resource length in bytes.'''
        ...
    
    @property
    def psd_version(self) -> int:
        ...
    
    @classmethod
    @property
    def RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @classmethod
    @property
    def PSB_RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @property
    def version(self) -> int:
        '''Gets the version of the placed layer in the PSD file, usually 3.'''
        ...
    
    @property
    def unique_id(self) -> Guid:
        ...
    
    @unique_id.setter
    def unique_id(self, value : Guid):
        ...
    
    @property
    def is_custom(self) -> bool:
        ...
    
    @is_custom.setter
    def is_custom(self, value : bool):
        ...
    
    @property
    def page_number(self) -> int:
        ...
    
    @page_number.setter
    def page_number(self, value : int):
        ...
    
    @property
    def total_pages(self) -> int:
        ...
    
    @total_pages.setter
    def total_pages(self, value : int):
        ...
    
    @property
    def anti_alias_policy(self) -> int:
        ...
    
    @anti_alias_policy.setter
    def anti_alias_policy(self, value : int):
        ...
    
    @property
    def placed_layer_type(self) -> aspose.psd.fileformats.psd.layers.layerresources.PlacedLayerType:
        ...
    
    @placed_layer_type.setter
    def placed_layer_type(self, value : aspose.psd.fileformats.psd.layers.layerresources.PlacedLayerType):
        ...
    
    @property
    def left(self) -> float:
        '''Gets the left location of the placed layer in the PSD file.'''
        ...
    
    @left.setter
    def left(self, value : float):
        '''Sets the left location of the placed layer in the PSD file.'''
        ...
    
    @property
    def top(self) -> float:
        '''Gets the top location of the placed layer in the PSD image.'''
        ...
    
    @top.setter
    def top(self, value : float):
        '''Sets the top location of the placed layer in the PSD image.'''
        ...
    
    @property
    def right(self) -> float:
        '''Gets the right location of the placed layer in the PSD file.'''
        ...
    
    @right.setter
    def right(self, value : float):
        '''Sets the right location of the placed layer in the PSD file.'''
        ...
    
    @property
    def bottom(self) -> float:
        '''Gets the bottom location of the placed layer in the PSD image.'''
        ...
    
    @bottom.setter
    def bottom(self, value : float):
        '''Sets the bottom location of the placed layer in the PSD image.'''
        ...
    
    @property
    def bounds(self) -> aspose.psd.Rectangle:
        '''Gets the bounds of the placed layer in the PSD file.'''
        ...
    
    @bounds.setter
    def bounds(self, value : aspose.psd.Rectangle):
        '''Sets the bounds of the placed layer in the PSD file.'''
        ...
    
    @property
    def transform_matrix(self) -> List[float]:
        ...
    
    @transform_matrix.setter
    def transform_matrix(self, value : List[float]):
        ...
    
    @property
    def horizontal_mesh_points(self) -> List[float]:
        ...
    
    @horizontal_mesh_points.setter
    def horizontal_mesh_points(self, value : List[float]):
        ...
    
    @property
    def vertical_mesh_points(self) -> List[float]:
        ...
    
    @vertical_mesh_points.setter
    def vertical_mesh_points(self, value : List[float]):
        ...
    
    @property
    def horizontal_mesh_point_unit(self) -> aspose.psd.fileformats.psd.layers.layerresources.typetoolinfostructures.UnitTypes:
        ...
    
    @horizontal_mesh_point_unit.setter
    def horizontal_mesh_point_unit(self, value : aspose.psd.fileformats.psd.layers.layerresources.typetoolinfostructures.UnitTypes):
        ...
    
    @property
    def vertical_mesh_point_unit(self) -> aspose.psd.fileformats.psd.layers.layerresources.typetoolinfostructures.UnitTypes:
        ...
    
    @vertical_mesh_point_unit.setter
    def vertical_mesh_point_unit(self, value : aspose.psd.fileformats.psd.layers.layerresources.typetoolinfostructures.UnitTypes):
        ...
    
    @property
    def value(self) -> float:
        '''Gets the warp value of the placed layer in the PSD image.'''
        ...
    
    @value.setter
    def value(self, value : float):
        '''Sets the warp value of the placed layer in the PSD image.'''
        ...
    
    @property
    def perspective(self) -> float:
        '''Gets the perspective value of the placed layer in the PSD file.'''
        ...
    
    @perspective.setter
    def perspective(self, value : float):
        '''Sets the perspective value of the placed layer in the PSD file.'''
        ...
    
    @property
    def perspective_other(self) -> float:
        ...
    
    @perspective_other.setter
    def perspective_other(self, value : float):
        ...
    
    @property
    def u_order(self) -> int:
        ...
    
    @u_order.setter
    def u_order(self, value : int):
        ...
    
    @property
    def v_order(self) -> int:
        ...
    
    @v_order.setter
    def v_order(self, value : int):
        ...
    
    @property
    def items(self) -> List[aspose.psd.fileformats.psd.layers.layerresources.OSTypeStructure]:
        '''Gets the warp items.'''
        ...
    
    @items.setter
    def items(self, value : List[aspose.psd.fileformats.psd.layers.layerresources.OSTypeStructure]):
        '''Sets the warp items.'''
        ...
    
    ...

class PostResource(AdjustmentLayerResource):
    '''Class PostResource. Posterize layer settings.'''
    
    def save(self, stream_container : aspose.psd.StreamContainer, psd_version : int):
        '''Saves the resource to the specified stream container.
        
        :param stream_container: The stream container to save to.
        :param psd_version: The PSD version.'''
        ...
    
    @property
    def signature(self) -> int:
        '''Gets the signature.'''
        ...
    
    @property
    def key(self) -> int:
        '''Gets the layer resource key.'''
        ...
    
    @property
    def length(self) -> int:
        '''Gets the layer resource length in bytes.'''
        ...
    
    @property
    def psd_version(self) -> int:
        ...
    
    @classmethod
    @property
    def RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @classmethod
    @property
    def PSB_RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @property
    def levels(self) -> int:
        '''Levels of Posterize layer.'''
        ...
    
    @levels.setter
    def levels(self, value : int):
        '''Levels of Posterize layer.'''
        ...
    
    @classmethod
    @property
    def TYPE_TOOL_KEY(cls) -> int:
        ...
    
    ...

class PtFlResource(FillLayerResource):
    '''Class PtFlResource. Contains Pattern Fill Layer Data.'''
    
    def save(self, stream_container : aspose.psd.StreamContainer, psd_version : int):
        '''Saves the resource to the specified stream container.
        
        :param stream_container: The stream container to save to.
        :param psd_version: The PSD version.'''
        ...
    
    @property
    def signature(self) -> int:
        '''Gets the layer resource signature.'''
        ...
    
    @property
    def key(self) -> int:
        '''Gets the layer resource key.'''
        ...
    
    @property
    def length(self) -> int:
        '''Gets the layer resource length in bytes.'''
        ...
    
    @property
    def psd_version(self) -> int:
        ...
    
    @classmethod
    @property
    def RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @classmethod
    @property
    def PSB_RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @property
    def pattern_name(self) -> str:
        ...
    
    @pattern_name.setter
    def pattern_name(self, value : str):
        ...
    
    @property
    def offset(self) -> aspose.psd.Point:
        '''Gets the offset.'''
        ...
    
    @offset.setter
    def offset(self, value : aspose.psd.Point):
        '''Sets the offset.'''
        ...
    
    @property
    def scale(self) -> float:
        '''Gets the scale.'''
        ...
    
    @scale.setter
    def scale(self, value : float):
        '''Sets the scale.'''
        ...
    
    @property
    def is_linked_with_layer(self) -> bool:
        ...
    
    @is_linked_with_layer.setter
    def is_linked_with_layer(self, value : bool):
        ...
    
    @property
    def align_with_layer(self) -> bool:
        ...
    
    @align_with_layer.setter
    def align_with_layer(self, value : bool):
        ...
    
    @property
    def pattern_id(self) -> str:
        ...
    
    @pattern_id.setter
    def pattern_id(self, value : str):
        ...
    
    @classmethod
    @property
    def TYPE_TOOL_KEY(cls) -> int:
        ...
    
    ...

class ShmdResource(aspose.psd.fileformats.psd.layers.LayerResource):
    '''Class ShmdResource. Metadata settings'''
    
    def save(self, stream_container : aspose.psd.StreamContainer, psd_version : int):
        '''Saves the specified stream container.
        
        :param stream_container: The stream container.
        :param psd_version: The PSD version.'''
        ...
    
    @property
    def signature(self) -> int:
        '''Gets the signature.'''
        ...
    
    @property
    def key(self) -> int:
        '''Gets the layer resource key.'''
        ...
    
    @property
    def length(self) -> int:
        '''Gets the layer resource length in bytes.'''
        ...
    
    @property
    def psd_version(self) -> int:
        ...
    
    @classmethod
    @property
    def RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @classmethod
    @property
    def PSB_RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @property
    def layer_created_date_time(self) -> DateTime:
        ...
    
    @layer_created_date_time.setter
    def layer_created_date_time(self, value : DateTime):
        ...
    
    @property
    def sub_resources(self) -> List[aspose.psd.fileformats.psd.layers.LayerResource]:
        ...
    
    @classmethod
    @property
    def TYPE_TOOL_KEY(cls) -> int:
        ...
    
    @classmethod
    @property
    def SUB_RESOURCE_HEADER_LENGTH(cls) -> int:
        ...
    
    ...

class SmartObjectResource(PlacedResource):
    '''Defines the SmartObjectResource class that contains information about a smart object layer in a PSD file.
    Is is the base class for Sold and Sole resources that is used to support smart object layers in the Adobe® Photoshop® images.'''
    
    def save(self, stream_container : aspose.psd.StreamContainer, psd_version : int):
        '''Saves the smart object resource to the specified stream container.
        
        :param stream_container: The stream container to save to.
        :param psd_version: The PSD version.'''
        ...
    
    @property
    def signature(self) -> int:
        '''Gets the smart object resource signature.'''
        ...
    
    @property
    def key(self) -> int:
        '''Gets the layer resource key.'''
        ...
    
    @property
    def length(self) -> int:
        '''Gets the smart object resource length in bytes.'''
        ...
    
    @property
    def psd_version(self) -> int:
        ...
    
    @classmethod
    @property
    def RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @classmethod
    @property
    def PSB_RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @property
    def version(self) -> int:
        '''Gets the version of the placed layer in the PSD file, usually 3.'''
        ...
    
    @property
    def unique_id(self) -> Guid:
        ...
    
    @unique_id.setter
    def unique_id(self, value : Guid):
        ...
    
    @property
    def is_custom(self) -> bool:
        ...
    
    @is_custom.setter
    def is_custom(self, value : bool):
        ...
    
    @property
    def page_number(self) -> int:
        ...
    
    @page_number.setter
    def page_number(self, value : int):
        ...
    
    @property
    def total_pages(self) -> int:
        ...
    
    @total_pages.setter
    def total_pages(self, value : int):
        ...
    
    @property
    def anti_alias_policy(self) -> int:
        ...
    
    @anti_alias_policy.setter
    def anti_alias_policy(self, value : int):
        ...
    
    @property
    def placed_layer_type(self) -> aspose.psd.fileformats.psd.layers.layerresources.PlacedLayerType:
        ...
    
    @placed_layer_type.setter
    def placed_layer_type(self, value : aspose.psd.fileformats.psd.layers.layerresources.PlacedLayerType):
        ...
    
    @property
    def left(self) -> float:
        '''Gets the left location of the placed layer in the PSD file.'''
        ...
    
    @left.setter
    def left(self, value : float):
        '''Sets the left location of the placed layer in the PSD file.'''
        ...
    
    @property
    def top(self) -> float:
        '''Gets the top location of the placed layer in the PSD image.'''
        ...
    
    @top.setter
    def top(self, value : float):
        '''Sets the top location of the placed layer in the PSD image.'''
        ...
    
    @property
    def right(self) -> float:
        '''Gets the right location of the placed layer in the PSD file.'''
        ...
    
    @right.setter
    def right(self, value : float):
        '''Sets the right location of the placed layer in the PSD file.'''
        ...
    
    @property
    def bottom(self) -> float:
        '''Gets the bottom location of the placed layer in the PSD image.'''
        ...
    
    @bottom.setter
    def bottom(self, value : float):
        '''Sets the bottom location of the placed layer in the PSD image.'''
        ...
    
    @property
    def bounds(self) -> aspose.psd.Rectangle:
        '''Gets the bounds of the placed layer in the PSD file.'''
        ...
    
    @bounds.setter
    def bounds(self, value : aspose.psd.Rectangle):
        '''Sets the bounds of the placed layer in the PSD file.'''
        ...
    
    @property
    def transform_matrix(self) -> List[float]:
        ...
    
    @transform_matrix.setter
    def transform_matrix(self, value : List[float]):
        ...
    
    @property
    def horizontal_mesh_points(self) -> List[float]:
        ...
    
    @horizontal_mesh_points.setter
    def horizontal_mesh_points(self, value : List[float]):
        ...
    
    @property
    def vertical_mesh_points(self) -> List[float]:
        ...
    
    @vertical_mesh_points.setter
    def vertical_mesh_points(self, value : List[float]):
        ...
    
    @property
    def horizontal_mesh_point_unit(self) -> aspose.psd.fileformats.psd.layers.layerresources.typetoolinfostructures.UnitTypes:
        ...
    
    @horizontal_mesh_point_unit.setter
    def horizontal_mesh_point_unit(self, value : aspose.psd.fileformats.psd.layers.layerresources.typetoolinfostructures.UnitTypes):
        ...
    
    @property
    def vertical_mesh_point_unit(self) -> aspose.psd.fileformats.psd.layers.layerresources.typetoolinfostructures.UnitTypes:
        ...
    
    @vertical_mesh_point_unit.setter
    def vertical_mesh_point_unit(self, value : aspose.psd.fileformats.psd.layers.layerresources.typetoolinfostructures.UnitTypes):
        ...
    
    @property
    def value(self) -> float:
        '''Gets the warp value of the placed layer in the PSD image.'''
        ...
    
    @value.setter
    def value(self, value : float):
        '''Sets the warp value of the placed layer in the PSD image.'''
        ...
    
    @property
    def perspective(self) -> float:
        '''Gets the perspective value of the placed layer in the PSD file.'''
        ...
    
    @perspective.setter
    def perspective(self, value : float):
        '''Sets the perspective value of the placed layer in the PSD file.'''
        ...
    
    @property
    def perspective_other(self) -> float:
        ...
    
    @perspective_other.setter
    def perspective_other(self, value : float):
        ...
    
    @property
    def u_order(self) -> int:
        ...
    
    @u_order.setter
    def u_order(self, value : int):
        ...
    
    @property
    def v_order(self) -> int:
        ...
    
    @v_order.setter
    def v_order(self, value : int):
        ...
    
    @property
    def items(self) -> List[aspose.psd.fileformats.psd.layers.layerresources.OSTypeStructure]:
        '''Gets the descriptor items of the smart object layer data in the PSD file.'''
        ...
    
    @items.setter
    def items(self, value : List[aspose.psd.fileformats.psd.layers.layerresources.OSTypeStructure]):
        '''Sets the descriptor items of the smart object layer data in the PSD file.'''
        ...
    
    @property
    def comp_id(self) -> int:
        ...
    
    @comp_id.setter
    def comp_id(self, value : int):
        ...
    
    @property
    def original_comp_id(self) -> int:
        ...
    
    @property
    def placed_id(self) -> Guid:
        ...
    
    @placed_id.setter
    def placed_id(self, value : Guid):
        ...
    
    @property
    def non_affine_transform_matrix(self) -> List[float]:
        ...
    
    @non_affine_transform_matrix.setter
    def non_affine_transform_matrix(self, value : List[float]):
        ...
    
    @property
    def crop(self) -> int:
        '''Gets the crop of the smart object layer data in the PSD image.'''
        ...
    
    @crop.setter
    def crop(self, value : int):
        '''Sets the crop of the smart object layer data in the PSD image.'''
        ...
    
    @property
    def frame_count(self) -> int:
        ...
    
    @frame_count.setter
    def frame_count(self, value : int):
        ...
    
    @property
    def resolution(self) -> float:
        '''Gets the resolution of the smart object layer data in the PSD file.'''
        ...
    
    @resolution.setter
    def resolution(self, value : float):
        '''Sets the resolution of the smart object layer data in the PSD file.'''
        ...
    
    @property
    def resolution_unit(self) -> aspose.psd.fileformats.psd.layers.layerresources.typetoolinfostructures.UnitTypes:
        ...
    
    @resolution_unit.setter
    def resolution_unit(self, value : aspose.psd.fileformats.psd.layers.layerresources.typetoolinfostructures.UnitTypes):
        ...
    
    @property
    def comp(self) -> int:
        '''Gets the comp value of the smart object layer data in the PSD file.
        :Layer comps in Smart Objects:`https://helpx.adobe.com/photoshop/using/layer-comps.html`'''
        ...
    
    @comp.setter
    def comp(self, value : int):
        '''Sets the comp value of the smart object layer data in the PSD file.
        :Layer comps in Smart Objects:`https://helpx.adobe.com/photoshop/using/layer-comps.html`'''
        ...
    
    @property
    def width(self) -> float:
        '''Gets the width.'''
        ...
    
    @width.setter
    def width(self, value : float):
        '''Sets the width.'''
        ...
    
    @property
    def height(self) -> float:
        '''Gets the height.'''
        ...
    
    @height.setter
    def height(self, value : float):
        '''Sets the height.'''
        ...
    
    @property
    def frame_step_numerator(self) -> int:
        ...
    
    @frame_step_numerator.setter
    def frame_step_numerator(self, value : int):
        ...
    
    @property
    def frame_step_denominator(self) -> int:
        ...
    
    @frame_step_denominator.setter
    def frame_step_denominator(self, value : int):
        ...
    
    @property
    def duration_numerator(self) -> int:
        ...
    
    @duration_numerator.setter
    def duration_numerator(self, value : int):
        ...
    
    @property
    def duration_denominator(self) -> int:
        ...
    
    @duration_denominator.setter
    def duration_denominator(self, value : int):
        ...
    
    ...

class SmartResourceCreator:
    '''Defines the SmartResourceCreator class that can create PlLd, SoLd and SoLe resources.
    Is is used to support smart object layers in the Adobe® Photoshop® images.'''
    
    def generate_placed_resource(self) -> aspose.psd.fileformats.psd.layers.layerresources.PlLdResource:
        '''Generates the placed resource.
        
        :returns: The generated :py:class:`aspose.psd.fileformats.psd.layers.layerresources.PlLdResource` instance.'''
        ...
    
    def generate_smart_embedded_resource(self) -> aspose.psd.fileformats.psd.layers.layerresources.SoLdResource:
        '''Generates the embedded smart object resource.
        
        :returns: The generated :py:class:`aspose.psd.fileformats.psd.layers.layerresources.SoLdResource` instance.'''
        ...
    
    def generate_smart_external_resource(self) -> aspose.psd.fileformats.psd.layers.layerresources.SoLeResource:
        '''Generates the external smart object resource.
        
        :returns: The generated :py:class:`aspose.psd.fileformats.psd.layers.layerresources.SoLeResource` instance.'''
        ...
    
    ...

class SoCoResource(FillLayerResource):
    '''Class SoCoResource.
    This resource contains information about Color Fill Layers'''
    
    def save(self, stream_container : aspose.psd.StreamContainer, psd_version : int):
        '''Saves the resource to the specified stream container.
        
        :param stream_container: The stream container to save to.
        :param psd_version: The PSD version.'''
        ...
    
    @property
    def signature(self) -> int:
        '''Gets the layer resource signature.'''
        ...
    
    @property
    def key(self) -> int:
        '''Gets the layer resource key.'''
        ...
    
    @property
    def length(self) -> int:
        '''Gets the layer resource length in bytes.'''
        ...
    
    @property
    def psd_version(self) -> int:
        ...
    
    @classmethod
    @property
    def RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @classmethod
    @property
    def PSB_RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @property
    def color(self) -> aspose.psd.Color:
        '''Gets the RGB color .'''
        ...
    
    @color.setter
    def color(self, value : aspose.psd.Color):
        '''Gets the RGB color .'''
        ...
    
    @classmethod
    @property
    def TYPE_TOOL_KEY(cls) -> int:
        ...
    
    ...

class SoLdResource(SmartObjectResource):
    '''Defines the SoLdResource class that contains information about a smart object layer in a PSD file.
    Is is used to support smart object layers in the Adobe® Photoshop® images.'''
    
    def save(self, stream_container : aspose.psd.StreamContainer, psd_version : int):
        '''Saves the smart object resource to the specified stream container.
        
        :param stream_container: The stream container to save to.
        :param psd_version: The PSD version.'''
        ...
    
    @property
    def signature(self) -> int:
        '''Gets the smart object resource signature.'''
        ...
    
    @property
    def key(self) -> int:
        '''Gets the SoLd smart object layer resource key.'''
        ...
    
    @property
    def length(self) -> int:
        '''Gets the smart object resource length in bytes.'''
        ...
    
    @property
    def psd_version(self) -> int:
        ...
    
    @classmethod
    @property
    def RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @classmethod
    @property
    def PSB_RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @property
    def version(self) -> int:
        '''Gets the version of the placed layer in the PSD file, usually 3.'''
        ...
    
    @property
    def unique_id(self) -> Guid:
        ...
    
    @unique_id.setter
    def unique_id(self, value : Guid):
        ...
    
    @property
    def is_custom(self) -> bool:
        ...
    
    @is_custom.setter
    def is_custom(self, value : bool):
        ...
    
    @property
    def page_number(self) -> int:
        ...
    
    @page_number.setter
    def page_number(self, value : int):
        ...
    
    @property
    def total_pages(self) -> int:
        ...
    
    @total_pages.setter
    def total_pages(self, value : int):
        ...
    
    @property
    def anti_alias_policy(self) -> int:
        ...
    
    @anti_alias_policy.setter
    def anti_alias_policy(self, value : int):
        ...
    
    @property
    def placed_layer_type(self) -> aspose.psd.fileformats.psd.layers.layerresources.PlacedLayerType:
        ...
    
    @placed_layer_type.setter
    def placed_layer_type(self, value : aspose.psd.fileformats.psd.layers.layerresources.PlacedLayerType):
        ...
    
    @property
    def left(self) -> float:
        '''Gets the left location of the placed layer in the PSD file.'''
        ...
    
    @left.setter
    def left(self, value : float):
        '''Sets the left location of the placed layer in the PSD file.'''
        ...
    
    @property
    def top(self) -> float:
        '''Gets the top location of the placed layer in the PSD image.'''
        ...
    
    @top.setter
    def top(self, value : float):
        '''Sets the top location of the placed layer in the PSD image.'''
        ...
    
    @property
    def right(self) -> float:
        '''Gets the right location of the placed layer in the PSD file.'''
        ...
    
    @right.setter
    def right(self, value : float):
        '''Sets the right location of the placed layer in the PSD file.'''
        ...
    
    @property
    def bottom(self) -> float:
        '''Gets the bottom location of the placed layer in the PSD image.'''
        ...
    
    @bottom.setter
    def bottom(self, value : float):
        '''Sets the bottom location of the placed layer in the PSD image.'''
        ...
    
    @property
    def bounds(self) -> aspose.psd.Rectangle:
        '''Gets the bounds of the placed layer in the PSD file.'''
        ...
    
    @bounds.setter
    def bounds(self, value : aspose.psd.Rectangle):
        '''Sets the bounds of the placed layer in the PSD file.'''
        ...
    
    @property
    def transform_matrix(self) -> List[float]:
        ...
    
    @transform_matrix.setter
    def transform_matrix(self, value : List[float]):
        ...
    
    @property
    def horizontal_mesh_points(self) -> List[float]:
        ...
    
    @horizontal_mesh_points.setter
    def horizontal_mesh_points(self, value : List[float]):
        ...
    
    @property
    def vertical_mesh_points(self) -> List[float]:
        ...
    
    @vertical_mesh_points.setter
    def vertical_mesh_points(self, value : List[float]):
        ...
    
    @property
    def horizontal_mesh_point_unit(self) -> aspose.psd.fileformats.psd.layers.layerresources.typetoolinfostructures.UnitTypes:
        ...
    
    @horizontal_mesh_point_unit.setter
    def horizontal_mesh_point_unit(self, value : aspose.psd.fileformats.psd.layers.layerresources.typetoolinfostructures.UnitTypes):
        ...
    
    @property
    def vertical_mesh_point_unit(self) -> aspose.psd.fileformats.psd.layers.layerresources.typetoolinfostructures.UnitTypes:
        ...
    
    @vertical_mesh_point_unit.setter
    def vertical_mesh_point_unit(self, value : aspose.psd.fileformats.psd.layers.layerresources.typetoolinfostructures.UnitTypes):
        ...
    
    @property
    def value(self) -> float:
        '''Gets the warp value of the placed layer in the PSD image.'''
        ...
    
    @value.setter
    def value(self, value : float):
        '''Sets the warp value of the placed layer in the PSD image.'''
        ...
    
    @property
    def perspective(self) -> float:
        '''Gets the perspective value of the placed layer in the PSD file.'''
        ...
    
    @perspective.setter
    def perspective(self, value : float):
        '''Sets the perspective value of the placed layer in the PSD file.'''
        ...
    
    @property
    def perspective_other(self) -> float:
        ...
    
    @perspective_other.setter
    def perspective_other(self, value : float):
        ...
    
    @property
    def u_order(self) -> int:
        ...
    
    @u_order.setter
    def u_order(self, value : int):
        ...
    
    @property
    def v_order(self) -> int:
        ...
    
    @v_order.setter
    def v_order(self, value : int):
        ...
    
    @property
    def items(self) -> List[aspose.psd.fileformats.psd.layers.layerresources.OSTypeStructure]:
        '''Gets the descriptor items of the smart object layer data in the PSD file.'''
        ...
    
    @items.setter
    def items(self, value : List[aspose.psd.fileformats.psd.layers.layerresources.OSTypeStructure]):
        '''Sets the descriptor items of the smart object layer data in the PSD file.'''
        ...
    
    @property
    def comp_id(self) -> int:
        ...
    
    @comp_id.setter
    def comp_id(self, value : int):
        ...
    
    @property
    def original_comp_id(self) -> int:
        ...
    
    @property
    def placed_id(self) -> Guid:
        ...
    
    @placed_id.setter
    def placed_id(self, value : Guid):
        ...
    
    @property
    def non_affine_transform_matrix(self) -> List[float]:
        ...
    
    @non_affine_transform_matrix.setter
    def non_affine_transform_matrix(self, value : List[float]):
        ...
    
    @property
    def crop(self) -> int:
        '''Gets the crop of the smart object layer data in the PSD image.'''
        ...
    
    @crop.setter
    def crop(self, value : int):
        '''Sets the crop of the smart object layer data in the PSD image.'''
        ...
    
    @property
    def frame_count(self) -> int:
        ...
    
    @frame_count.setter
    def frame_count(self, value : int):
        ...
    
    @property
    def resolution(self) -> float:
        '''Gets the resolution of the smart object layer data in the PSD file.'''
        ...
    
    @resolution.setter
    def resolution(self, value : float):
        '''Sets the resolution of the smart object layer data in the PSD file.'''
        ...
    
    @property
    def resolution_unit(self) -> aspose.psd.fileformats.psd.layers.layerresources.typetoolinfostructures.UnitTypes:
        ...
    
    @resolution_unit.setter
    def resolution_unit(self, value : aspose.psd.fileformats.psd.layers.layerresources.typetoolinfostructures.UnitTypes):
        ...
    
    @property
    def comp(self) -> int:
        '''Gets the comp value of the smart object layer data in the PSD file.
        :Layer comps in Smart Objects:`https://helpx.adobe.com/photoshop/using/layer-comps.html`'''
        ...
    
    @comp.setter
    def comp(self, value : int):
        '''Sets the comp value of the smart object layer data in the PSD file.
        :Layer comps in Smart Objects:`https://helpx.adobe.com/photoshop/using/layer-comps.html`'''
        ...
    
    @property
    def width(self) -> float:
        '''Gets the width.'''
        ...
    
    @width.setter
    def width(self, value : float):
        '''Sets the width.'''
        ...
    
    @property
    def height(self) -> float:
        '''Gets the height.'''
        ...
    
    @height.setter
    def height(self, value : float):
        '''Sets the height.'''
        ...
    
    @property
    def frame_step_numerator(self) -> int:
        ...
    
    @frame_step_numerator.setter
    def frame_step_numerator(self, value : int):
        ...
    
    @property
    def frame_step_denominator(self) -> int:
        ...
    
    @frame_step_denominator.setter
    def frame_step_denominator(self, value : int):
        ...
    
    @property
    def duration_numerator(self) -> int:
        ...
    
    @duration_numerator.setter
    def duration_numerator(self, value : int):
        ...
    
    @property
    def duration_denominator(self) -> int:
        ...
    
    @duration_denominator.setter
    def duration_denominator(self, value : int):
        ...
    
    @classmethod
    @property
    def TYPE_TOOL_KEY(cls) -> int:
        ...
    
    ...

class SoLeResource(SmartObjectResource):
    '''Defines the SoLeResource class that contains information about a smart object layer in a PSD file.
    Is is used to support smart object layers with external file links in the Adobe® Photoshop® images.'''
    
    def save(self, stream_container : aspose.psd.StreamContainer, psd_version : int):
        '''Saves the smart object resource to the specified stream container.
        
        :param stream_container: The stream container to save to.
        :param psd_version: The PSD version.'''
        ...
    
    @property
    def signature(self) -> int:
        '''Gets the smart object resource signature.'''
        ...
    
    @property
    def key(self) -> int:
        '''Gets the Sole smart object layer resource key.'''
        ...
    
    @property
    def length(self) -> int:
        '''Gets the smart object resource length in bytes.'''
        ...
    
    @property
    def psd_version(self) -> int:
        ...
    
    @classmethod
    @property
    def RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @classmethod
    @property
    def PSB_RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @property
    def version(self) -> int:
        '''Gets the version of the placed layer in the PSD file, usually 3.'''
        ...
    
    @property
    def unique_id(self) -> Guid:
        ...
    
    @unique_id.setter
    def unique_id(self, value : Guid):
        ...
    
    @property
    def is_custom(self) -> bool:
        ...
    
    @is_custom.setter
    def is_custom(self, value : bool):
        ...
    
    @property
    def page_number(self) -> int:
        ...
    
    @page_number.setter
    def page_number(self, value : int):
        ...
    
    @property
    def total_pages(self) -> int:
        ...
    
    @total_pages.setter
    def total_pages(self, value : int):
        ...
    
    @property
    def anti_alias_policy(self) -> int:
        ...
    
    @anti_alias_policy.setter
    def anti_alias_policy(self, value : int):
        ...
    
    @property
    def placed_layer_type(self) -> aspose.psd.fileformats.psd.layers.layerresources.PlacedLayerType:
        ...
    
    @placed_layer_type.setter
    def placed_layer_type(self, value : aspose.psd.fileformats.psd.layers.layerresources.PlacedLayerType):
        ...
    
    @property
    def left(self) -> float:
        '''Gets the left location of the placed layer in the PSD file.'''
        ...
    
    @left.setter
    def left(self, value : float):
        '''Sets the left location of the placed layer in the PSD file.'''
        ...
    
    @property
    def top(self) -> float:
        '''Gets the top location of the placed layer in the PSD image.'''
        ...
    
    @top.setter
    def top(self, value : float):
        '''Sets the top location of the placed layer in the PSD image.'''
        ...
    
    @property
    def right(self) -> float:
        '''Gets the right location of the placed layer in the PSD file.'''
        ...
    
    @right.setter
    def right(self, value : float):
        '''Sets the right location of the placed layer in the PSD file.'''
        ...
    
    @property
    def bottom(self) -> float:
        '''Gets the bottom location of the placed layer in the PSD image.'''
        ...
    
    @bottom.setter
    def bottom(self, value : float):
        '''Sets the bottom location of the placed layer in the PSD image.'''
        ...
    
    @property
    def bounds(self) -> aspose.psd.Rectangle:
        '''Gets the bounds of the placed layer in the PSD file.'''
        ...
    
    @bounds.setter
    def bounds(self, value : aspose.psd.Rectangle):
        '''Sets the bounds of the placed layer in the PSD file.'''
        ...
    
    @property
    def transform_matrix(self) -> List[float]:
        ...
    
    @transform_matrix.setter
    def transform_matrix(self, value : List[float]):
        ...
    
    @property
    def horizontal_mesh_points(self) -> List[float]:
        ...
    
    @horizontal_mesh_points.setter
    def horizontal_mesh_points(self, value : List[float]):
        ...
    
    @property
    def vertical_mesh_points(self) -> List[float]:
        ...
    
    @vertical_mesh_points.setter
    def vertical_mesh_points(self, value : List[float]):
        ...
    
    @property
    def horizontal_mesh_point_unit(self) -> aspose.psd.fileformats.psd.layers.layerresources.typetoolinfostructures.UnitTypes:
        ...
    
    @horizontal_mesh_point_unit.setter
    def horizontal_mesh_point_unit(self, value : aspose.psd.fileformats.psd.layers.layerresources.typetoolinfostructures.UnitTypes):
        ...
    
    @property
    def vertical_mesh_point_unit(self) -> aspose.psd.fileformats.psd.layers.layerresources.typetoolinfostructures.UnitTypes:
        ...
    
    @vertical_mesh_point_unit.setter
    def vertical_mesh_point_unit(self, value : aspose.psd.fileformats.psd.layers.layerresources.typetoolinfostructures.UnitTypes):
        ...
    
    @property
    def value(self) -> float:
        '''Gets the warp value of the placed layer in the PSD image.'''
        ...
    
    @value.setter
    def value(self, value : float):
        '''Sets the warp value of the placed layer in the PSD image.'''
        ...
    
    @property
    def perspective(self) -> float:
        '''Gets the perspective value of the placed layer in the PSD file.'''
        ...
    
    @perspective.setter
    def perspective(self, value : float):
        '''Sets the perspective value of the placed layer in the PSD file.'''
        ...
    
    @property
    def perspective_other(self) -> float:
        ...
    
    @perspective_other.setter
    def perspective_other(self, value : float):
        ...
    
    @property
    def u_order(self) -> int:
        ...
    
    @u_order.setter
    def u_order(self, value : int):
        ...
    
    @property
    def v_order(self) -> int:
        ...
    
    @v_order.setter
    def v_order(self, value : int):
        ...
    
    @property
    def items(self) -> List[aspose.psd.fileformats.psd.layers.layerresources.OSTypeStructure]:
        '''Gets the descriptor items of the smart object layer data in the PSD file.'''
        ...
    
    @items.setter
    def items(self, value : List[aspose.psd.fileformats.psd.layers.layerresources.OSTypeStructure]):
        '''Sets the descriptor items of the smart object layer data in the PSD file.'''
        ...
    
    @property
    def comp_id(self) -> int:
        ...
    
    @comp_id.setter
    def comp_id(self, value : int):
        ...
    
    @property
    def original_comp_id(self) -> int:
        ...
    
    @property
    def placed_id(self) -> Guid:
        ...
    
    @placed_id.setter
    def placed_id(self, value : Guid):
        ...
    
    @property
    def non_affine_transform_matrix(self) -> List[float]:
        ...
    
    @non_affine_transform_matrix.setter
    def non_affine_transform_matrix(self, value : List[float]):
        ...
    
    @property
    def crop(self) -> int:
        '''Gets the crop of the smart object layer data in the PSD image.'''
        ...
    
    @crop.setter
    def crop(self, value : int):
        '''Sets the crop of the smart object layer data in the PSD image.'''
        ...
    
    @property
    def frame_count(self) -> int:
        ...
    
    @frame_count.setter
    def frame_count(self, value : int):
        ...
    
    @property
    def resolution(self) -> float:
        '''Gets the resolution of the smart object layer data in the PSD file.'''
        ...
    
    @resolution.setter
    def resolution(self, value : float):
        '''Sets the resolution of the smart object layer data in the PSD file.'''
        ...
    
    @property
    def resolution_unit(self) -> aspose.psd.fileformats.psd.layers.layerresources.typetoolinfostructures.UnitTypes:
        ...
    
    @resolution_unit.setter
    def resolution_unit(self, value : aspose.psd.fileformats.psd.layers.layerresources.typetoolinfostructures.UnitTypes):
        ...
    
    @property
    def comp(self) -> int:
        '''Gets the comp value of the smart object layer data in the PSD file.
        :Layer comps in Smart Objects:`https://helpx.adobe.com/photoshop/using/layer-comps.html`'''
        ...
    
    @comp.setter
    def comp(self, value : int):
        '''Sets the comp value of the smart object layer data in the PSD file.
        :Layer comps in Smart Objects:`https://helpx.adobe.com/photoshop/using/layer-comps.html`'''
        ...
    
    @property
    def width(self) -> float:
        '''Gets the width.'''
        ...
    
    @width.setter
    def width(self, value : float):
        '''Sets the width.'''
        ...
    
    @property
    def height(self) -> float:
        '''Gets the height.'''
        ...
    
    @height.setter
    def height(self, value : float):
        '''Sets the height.'''
        ...
    
    @property
    def frame_step_numerator(self) -> int:
        ...
    
    @frame_step_numerator.setter
    def frame_step_numerator(self, value : int):
        ...
    
    @property
    def frame_step_denominator(self) -> int:
        ...
    
    @frame_step_denominator.setter
    def frame_step_denominator(self, value : int):
        ...
    
    @property
    def duration_numerator(self) -> int:
        ...
    
    @duration_numerator.setter
    def duration_numerator(self, value : int):
        ...
    
    @property
    def duration_denominator(self) -> int:
        ...
    
    @duration_denominator.setter
    def duration_denominator(self, value : int):
        ...
    
    @classmethod
    @property
    def TYPE_TOOL_KEY(cls) -> int:
        ...
    
    ...

class Txt2Resource(aspose.psd.fileformats.psd.layers.LayerResource):
    '''Txt2 resource class'''
    
    def save(self, stream_container : aspose.psd.StreamContainer, psd_version : int):
        '''Saves the specified stream container.
        
        :param stream_container: The stream container.
        :param psd_version: The PSD version.'''
        ...
    
    def get_text_data(self) -> List[str]:
        '''Gets the text record from resource data.
        
        :returns: Array of text record'''
        ...
    
    def add_text_record(self, text : str, bounds : aspose.psd.RectangleF) -> int:
        '''Adds the text record to Resource and returns id of text record.
        
        :param text: The record text.
        :param bounds: The bounds.
        :returns: Returns Id of text record for resource'''
        ...
    
    @property
    def signature(self) -> int:
        '''Gets the layer resource signature.'''
        ...
    
    @property
    def key(self) -> int:
        '''Gets the layer resource key.'''
        ...
    
    @property
    def length(self) -> int:
        '''Gets the layer resource length in bytes.'''
        ...
    
    @property
    def psd_version(self) -> int:
        ...
    
    @classmethod
    @property
    def RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @classmethod
    @property
    def PSB_RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @property
    def data(self) -> bytes:
        '''Gets the data.'''
        ...
    
    @data.setter
    def data(self, value : bytes):
        '''Sets the data.'''
        ...
    
    @classmethod
    @property
    def TYPE_TOOL_KEY(cls) -> int:
        ...
    
    ...

class TypeToolFontInfo:
    '''Contains information about type tool font.'''
    
    def save(self, stream_container : aspose.psd.StreamContainer):
        '''Saves the :py:class:`aspose.psd.fileformats.psd.layers.layerresources.TypeToolFontInfo` information to the specified stream container.
        
        :param stream_container: The stream container to save to.'''
        ...
    
    @property
    def mark_value(self) -> int:
        ...
    
    @mark_value.setter
    def mark_value(self, value : int):
        ...
    
    @property
    def font_type_data(self) -> int:
        ...
    
    @font_type_data.setter
    def font_type_data(self, value : int):
        ...
    
    @property
    def font_name(self) -> str:
        ...
    
    @font_name.setter
    def font_name(self, value : str):
        ...
    
    @property
    def font_family(self) -> str:
        ...
    
    @font_family.setter
    def font_family(self, value : str):
        ...
    
    @property
    def font_style(self) -> str:
        ...
    
    @font_style.setter
    def font_style(self, value : str):
        ...
    
    @property
    def script_value(self) -> int:
        ...
    
    @script_value.setter
    def script_value(self, value : int):
        ...
    
    @property
    def design_axes(self) -> int:
        ...
    
    @design_axes.setter
    def design_axes(self, value : int):
        ...
    
    @property
    def design_vector_value(self) -> int:
        ...
    
    @design_vector_value.setter
    def design_vector_value(self, value : int):
        ...
    
    @property
    def length(self) -> int:
        '''Gets the length.'''
        ...
    
    ...

class TypeToolInfo6Resource(aspose.psd.fileformats.psd.layers.LayerResource):
    '''The type tool information. For PSD version higher or equal to the 6.0.'''
    
    def save(self, stream_container : aspose.psd.StreamContainer, psd_version : int):
        '''Saves the resource to the specified stream container.
        
        :param stream_container: The stream container to save to.
        :param psd_version: The PSD version.'''
        ...
    
    @property
    def signature(self) -> int:
        '''Gets the layer resource signature.'''
        ...
    
    @property
    def key(self) -> int:
        '''Gets the layer resource key.'''
        ...
    
    @property
    def length(self) -> int:
        '''Gets the layer resource length in bytes.'''
        ...
    
    @property
    def psd_version(self) -> int:
        ...
    
    @classmethod
    @property
    def RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @classmethod
    @property
    def PSB_RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @property
    def warp_items(self) -> List[aspose.psd.fileformats.psd.layers.layerresources.OSTypeStructure]:
        ...
    
    @warp_items.setter
    def warp_items(self, value : List[aspose.psd.fileformats.psd.layers.layerresources.OSTypeStructure]):
        ...
    
    @property
    def warp_class_name(self) -> str:
        ...
    
    @warp_class_name.setter
    def warp_class_name(self, value : str):
        ...
    
    @property
    def warp_class_id(self) -> aspose.psd.fileformats.psd.layers.layerresources.ClassID:
        ...
    
    @warp_class_id.setter
    def warp_class_id(self, value : aspose.psd.fileformats.psd.layers.layerresources.ClassID):
        ...
    
    @property
    def warp_version(self) -> int:
        ...
    
    @warp_version.setter
    def warp_version(self, value : int):
        ...
    
    @property
    def warp_descriptor_version(self) -> int:
        ...
    
    @warp_descriptor_version.setter
    def warp_descriptor_version(self, value : int):
        ...
    
    @property
    def version(self) -> int:
        '''Gets the type tool version.'''
        ...
    
    @version.setter
    def version(self, value : int):
        '''Sets the type tool version.'''
        ...
    
    @property
    def left(self) -> int:
        '''Gets the left location.'''
        ...
    
    @left.setter
    def left(self, value : int):
        '''Sets the left location.'''
        ...
    
    @property
    def top(self) -> int:
        '''Gets the top  location.'''
        ...
    
    @top.setter
    def top(self, value : int):
        '''Sets the top  location.'''
        ...
    
    @property
    def right(self) -> int:
        '''Gets the right location.'''
        ...
    
    @right.setter
    def right(self, value : int):
        '''Sets the right location.'''
        ...
    
    @property
    def bottom(self) -> int:
        '''Gets the bottom location.'''
        ...
    
    @bottom.setter
    def bottom(self, value : int):
        '''Sets the bottom location.'''
        ...
    
    @property
    def transform_matrix(self) -> List[float]:
        ...
    
    @transform_matrix.setter
    def transform_matrix(self, value : List[float]):
        ...
    
    @property
    def text_version(self) -> int:
        ...
    
    @text_version.setter
    def text_version(self, value : int):
        ...
    
    @property
    def descriptor_version(self) -> int:
        ...
    
    @descriptor_version.setter
    def descriptor_version(self, value : int):
        ...
    
    @property
    def class_name(self) -> str:
        ...
    
    @class_name.setter
    def class_name(self, value : str):
        ...
    
    @property
    def class_id(self) -> aspose.psd.fileformats.psd.layers.layerresources.ClassID:
        ...
    
    @class_id.setter
    def class_id(self, value : aspose.psd.fileformats.psd.layers.layerresources.ClassID):
        ...
    
    @property
    def items(self) -> List[aspose.psd.fileformats.psd.layers.layerresources.OSTypeStructure]:
        '''Gets the items.'''
        ...
    
    @items.setter
    def items(self, value : List[aspose.psd.fileformats.psd.layers.layerresources.OSTypeStructure]):
        '''Sets the items.'''
        ...
    
    @classmethod
    @property
    def TYPE_TOOL_KEY(cls) -> int:
        ...
    
    ...

class TypeToolInfoResource(aspose.psd.fileformats.psd.layers.LayerResource):
    '''The type tool information. For PSD version lower than 6.0.'''
    
    def save(self, stream_container : aspose.psd.StreamContainer, psd_version : int):
        '''Saves the specified stream container.
        
        :param stream_container: The stream container.
        :param psd_version: The PSD version.'''
        ...
    
    @property
    def signature(self) -> int:
        '''Gets the layer resource signature.'''
        ...
    
    @property
    def key(self) -> int:
        '''Gets the layer resource key.'''
        ...
    
    @property
    def length(self) -> int:
        '''Gets the layer resource length in bytes.'''
        ...
    
    @property
    def psd_version(self) -> int:
        ...
    
    @classmethod
    @property
    def RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @classmethod
    @property
    def PSB_RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @property
    def version(self) -> int:
        '''Gets the version.'''
        ...
    
    @version.setter
    def version(self, value : int):
        '''Sets the version.'''
        ...
    
    @property
    def transform_matrix(self) -> List[float]:
        ...
    
    @transform_matrix.setter
    def transform_matrix(self, value : List[float]):
        ...
    
    @property
    def font_version(self) -> int:
        ...
    
    @font_version.setter
    def font_version(self, value : int):
        ...
    
    @property
    def fonts_count(self) -> int:
        ...
    
    @property
    def fonts(self) -> List[aspose.psd.fileformats.psd.layers.layerresources.TypeToolFontInfo]:
        '''Gets the fonts.'''
        ...
    
    @fonts.setter
    def fonts(self, value : List[aspose.psd.fileformats.psd.layers.layerresources.TypeToolFontInfo]):
        '''Sets the fonts.'''
        ...
    
    @property
    def styles_count(self) -> int:
        ...
    
    @property
    def styles(self) -> List[aspose.psd.fileformats.psd.layers.layerresources.TypeToolStyleInfo]:
        '''Gets the font styles.'''
        ...
    
    @styles.setter
    def styles(self, value : List[aspose.psd.fileformats.psd.layers.layerresources.TypeToolStyleInfo]):
        '''Sets the font styles.'''
        ...
    
    @property
    def type_value(self) -> int:
        ...
    
    @type_value.setter
    def type_value(self, value : int):
        ...
    
    @property
    def scale_factor(self) -> int:
        ...
    
    @scale_factor.setter
    def scale_factor(self, value : int):
        ...
    
    @property
    def character_count(self) -> int:
        ...
    
    @character_count.setter
    def character_count(self, value : int):
        ...
    
    @property
    def horizontal_placement(self) -> int:
        ...
    
    @horizontal_placement.setter
    def horizontal_placement(self, value : int):
        ...
    
    @property
    def vertical_placement(self) -> int:
        ...
    
    @vertical_placement.setter
    def vertical_placement(self, value : int):
        ...
    
    @property
    def selection_start(self) -> int:
        ...
    
    @selection_start.setter
    def selection_start(self, value : int):
        ...
    
    @property
    def selection_end(self) -> int:
        ...
    
    @selection_end.setter
    def selection_end(self, value : int):
        ...
    
    @property
    def line_count(self) -> int:
        ...
    
    @property
    def lines(self) -> List[aspose.psd.fileformats.psd.layers.layerresources.TypeToolLineInfo]:
        '''Gets the lines.'''
        ...
    
    @lines.setter
    def lines(self, value : List[aspose.psd.fileformats.psd.layers.layerresources.TypeToolLineInfo]):
        '''Sets the lines.'''
        ...
    
    @property
    def color_space_value(self) -> int:
        ...
    
    @color_space_value.setter
    def color_space_value(self, value : int):
        ...
    
    @property
    def r_component(self) -> int:
        ...
    
    @r_component.setter
    def r_component(self, value : int):
        ...
    
    @property
    def g_component(self) -> int:
        ...
    
    @g_component.setter
    def g_component(self, value : int):
        ...
    
    @property
    def b_component(self) -> int:
        ...
    
    @b_component.setter
    def b_component(self, value : int):
        ...
    
    @property
    def a_component(self) -> int:
        ...
    
    @a_component.setter
    def a_component(self, value : int):
        ...
    
    ...

class TypeToolLineInfo:
    '''Type tool line info.'''
    
    def save(self, stream_container : aspose.psd.StreamContainer, psd_version : int):
        '''Saves the :py:class:`aspose.psd.fileformats.psd.layers.layerresources.TypeToolLineInfo` information to the specified stream container.
        
        :param stream_container: The stream container to save to.
        :param psd_version: The PSD version.'''
        ...
    
    @property
    def char(self) -> char:
        '''Gets the char.'''
        ...
    
    @char.setter
    def char(self, value : char):
        '''Sets the char.'''
        ...
    
    ...

class TypeToolStyleInfo:
    '''Type tool style information.'''
    
    def save(self, stream_container : aspose.psd.StreamContainer, psd_version : int):
        '''Saves the :py:class:`aspose.psd.fileformats.psd.layers.layerresources.TypeToolFontInfo` information to the specified stream container.
        
        :param stream_container: The stream container to save to.
        :param psd_version: The PSD version.'''
        ...
    
    @property
    def mark_value(self) -> int:
        ...
    
    @mark_value.setter
    def mark_value(self, value : int):
        ...
    
    @property
    def face_mark_value(self) -> int:
        ...
    
    @face_mark_value.setter
    def face_mark_value(self, value : int):
        ...
    
    @property
    def size_value(self) -> int:
        ...
    
    @size_value.setter
    def size_value(self, value : int):
        ...
    
    @property
    def tracking_value(self) -> int:
        ...
    
    @tracking_value.setter
    def tracking_value(self, value : int):
        ...
    
    @property
    def kerning_value(self) -> int:
        ...
    
    @kerning_value.setter
    def kerning_value(self, value : int):
        ...
    
    @property
    def leading_value(self) -> int:
        ...
    
    @leading_value.setter
    def leading_value(self, value : int):
        ...
    
    @property
    def base_shift_value(self) -> int:
        ...
    
    @base_shift_value.setter
    def base_shift_value(self, value : int):
        ...
    
    @property
    def auto_kern(self) -> bool:
        ...
    
    @auto_kern.setter
    def auto_kern(self, value : bool):
        ...
    
    @property
    def rotate_down(self) -> bool:
        ...
    
    @rotate_down.setter
    def rotate_down(self, value : bool):
        ...
    
    ...

class UnknownResource(aspose.psd.fileformats.psd.layers.LayerResource):
    '''The unknown resource.'''
    
    def save(self, stream_container : aspose.psd.StreamContainer, psd_version : int):
        '''Saves the specified stream container.
        
        :param stream_container: The stream container.
        :param psd_version: The PSD version.'''
        ...
    
    @property
    def signature(self) -> int:
        '''Gets the layer resource signature.'''
        ...
    
    @property
    def key(self) -> int:
        '''Gets the layer resource key.'''
        ...
    
    @property
    def length(self) -> int:
        '''Gets the layer resource length in bytes.'''
        ...
    
    @property
    def psd_version(self) -> int:
        ...
    
    @classmethod
    @property
    def RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @classmethod
    @property
    def PSB_RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @property
    def data(self) -> bytes:
        '''Gets the data.'''
        ...
    
    @data.setter
    def data(self, value : bytes):
        '''Sets the data.'''
        ...
    
    ...

class VectorPath(IPath):
    '''The class that contains vector paths.'''
    
    def get_items(self) -> List[aspose.psd.fileformats.psd.layers.layerresources.IPathShape]:
        '''Gets array of Shapes in a Path.
        
        :returns: Array of IPathShape.'''
        ...
    
    def set_items(self, shapes : List[aspose.psd.fileformats.psd.layers.layerresources.IPathShape]):
        '''Sets array of Shapes in a Path.
        
        :param shapes: Array of IPathShape.'''
        ...
    
    @property
    def is_fill_starts_with_all_pixels(self) -> bool:
        ...
    
    @is_fill_starts_with_all_pixels.setter
    def is_fill_starts_with_all_pixels(self, value : bool):
        ...
    
    @property
    def version(self) -> int:
        '''Gets the version.'''
        ...
    
    @version.setter
    def version(self, value : int):
        '''Sets the version.'''
        ...
    
    @property
    def is_disabled(self) -> bool:
        ...
    
    @is_disabled.setter
    def is_disabled(self, value : bool):
        ...
    
    @property
    def is_not_linked(self) -> bool:
        ...
    
    @is_not_linked.setter
    def is_not_linked(self, value : bool):
        ...
    
    @property
    def is_inverted(self) -> bool:
        ...
    
    @is_inverted.setter
    def is_inverted(self, value : bool):
        ...
    
    ...

class VectorPathDataResource(aspose.psd.fileformats.psd.layers.LayerResource):
    '''Class VectorPathDataResource.
    This resource contains information about vector layer mask'''
    
    def save(self, stream_container : aspose.psd.StreamContainer, psd_version : int):
        '''Saves the resource to the specified stream container.
        
        :param stream_container: The stream container to save to.
        :param psd_version: The PSD version.'''
        ...
    
    @property
    def signature(self) -> int:
        '''Gets the signature.'''
        ...
    
    @property
    def key(self) -> int:
        '''Gets the layer resource key.'''
        ...
    
    @property
    def length(self) -> int:
        '''Gets the layer resource length in bytes.'''
        ...
    
    @property
    def psd_version(self) -> int:
        ...
    
    @classmethod
    @property
    def RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @classmethod
    @property
    def PSB_RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @property
    def paths(self) -> List[aspose.psd.fileformats.core.vectorpaths.VectorPathRecord]:
        '''Gets the path records.'''
        ...
    
    @paths.setter
    def paths(self, value : List[aspose.psd.fileformats.core.vectorpaths.VectorPathRecord]):
        '''Sets the path records.'''
        ...
    
    @property
    def version(self) -> int:
        '''Gets the version.'''
        ...
    
    @version.setter
    def version(self, value : int):
        '''Sets the version.'''
        ...
    
    @property
    def is_disabled(self) -> bool:
        ...
    
    @is_disabled.setter
    def is_disabled(self, value : bool):
        ...
    
    @property
    def is_not_linked(self) -> bool:
        ...
    
    @is_not_linked.setter
    def is_not_linked(self, value : bool):
        ...
    
    @property
    def is_inverted(self) -> bool:
        ...
    
    @is_inverted.setter
    def is_inverted(self, value : bool):
        ...
    
    ...

class VibAResource(AdjustmentLayerResource):
    '''VibA Resource.'''
    
    def save(self, stream_container : aspose.psd.StreamContainer, psd_version : int):
        '''Saves the resource to the specified stream container.
        
        :param stream_container: The stream container to save to.
        :param psd_version: The PSD version.'''
        ...
    
    @property
    def signature(self) -> int:
        '''Gets the signature.'''
        ...
    
    @property
    def key(self) -> int:
        '''Gets the layer resource key.'''
        ...
    
    @property
    def length(self) -> int:
        '''Gets the layer resource length in bytes.'''
        ...
    
    @property
    def psd_version(self) -> int:
        ...
    
    @classmethod
    @property
    def RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @classmethod
    @property
    def PSB_RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @property
    def vibrance(self) -> int:
        '''Gets vibrance value'''
        ...
    
    @vibrance.setter
    def vibrance(self, value : int):
        '''Sets vibrance value'''
        ...
    
    @property
    def saturation(self) -> int:
        '''Gets saturation value'''
        ...
    
    @saturation.setter
    def saturation(self, value : int):
        '''Sets saturation value'''
        ...
    
    @classmethod
    @property
    def TYPE_TOOL_KEY(cls) -> int:
        ...
    
    ...

class VmskResource(VectorPathDataResource):
    '''Class VmskResource.
    This resource contains information about vector layer mask'''
    
    def save(self, stream_container : aspose.psd.StreamContainer, psd_version : int):
        '''Saves the resource to the specified stream container.
        
        :param stream_container: The stream container to save to.
        :param psd_version: The PSD version.'''
        ...
    
    @property
    def signature(self) -> int:
        '''Gets the signature.'''
        ...
    
    @property
    def key(self) -> int:
        '''Gets the layer resource key.'''
        ...
    
    @property
    def length(self) -> int:
        '''Gets the layer resource length in bytes.'''
        ...
    
    @property
    def psd_version(self) -> int:
        ...
    
    @classmethod
    @property
    def RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @classmethod
    @property
    def PSB_RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @property
    def paths(self) -> List[aspose.psd.fileformats.core.vectorpaths.VectorPathRecord]:
        '''Gets the path records.'''
        ...
    
    @paths.setter
    def paths(self, value : List[aspose.psd.fileformats.core.vectorpaths.VectorPathRecord]):
        '''Sets the path records.'''
        ...
    
    @property
    def version(self) -> int:
        '''Gets the version.'''
        ...
    
    @version.setter
    def version(self, value : int):
        '''Sets the version.'''
        ...
    
    @property
    def is_disabled(self) -> bool:
        ...
    
    @is_disabled.setter
    def is_disabled(self, value : bool):
        ...
    
    @property
    def is_not_linked(self) -> bool:
        ...
    
    @is_not_linked.setter
    def is_not_linked(self, value : bool):
        ...
    
    @property
    def is_inverted(self) -> bool:
        ...
    
    @is_inverted.setter
    def is_inverted(self, value : bool):
        ...
    
    @classmethod
    @property
    def TYPE_TOOL_KEY(cls) -> int:
        ...
    
    ...

class VogkResource(aspose.psd.fileformats.psd.layers.LayerResource):
    '''The Vector Origination Data resource.'''
    
    def save(self, stream_container : aspose.psd.StreamContainer, psd_version : int):
        '''Saves the resource to the specified stream container.
        
        :param stream_container: The stream container to save to.
        :param psd_version: The PSD version.'''
        ...
    
    @property
    def signature(self) -> int:
        '''Gets the layer resource signature.'''
        ...
    
    @property
    def key(self) -> int:
        '''Gets the layer resource key.'''
        ...
    
    @property
    def length(self) -> int:
        '''Gets the layer resource length in bytes.'''
        ...
    
    @property
    def psd_version(self) -> int:
        ...
    
    @classmethod
    @property
    def RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @classmethod
    @property
    def PSB_RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @property
    def version(self) -> int:
        '''Gets the version.'''
        ...
    
    @version.setter
    def version(self, value : int):
        '''Sets the version.'''
        ...
    
    @property
    def shape_origin_settings(self) -> List[aspose.psd.fileformats.core.vectorpaths.VectorShapeOriginSettings]:
        ...
    
    @shape_origin_settings.setter
    def shape_origin_settings(self, value : List[aspose.psd.fileformats.core.vectorpaths.VectorShapeOriginSettings]):
        ...
    
    @classmethod
    @property
    def TYPE_TOOL_KEY(cls) -> int:
        ...
    
    ...

class VsmsResource(VectorPathDataResource):
    '''Class VsmsResource.
    This resource contains information about vector layer mask'''
    
    def save(self, stream_container : aspose.psd.StreamContainer, psd_version : int):
        '''Saves the resource to the specified stream container.
        
        :param stream_container: The stream container to save to.
        :param psd_version: The PSD version.'''
        ...
    
    @property
    def signature(self) -> int:
        '''Gets the signature.'''
        ...
    
    @property
    def key(self) -> int:
        '''Gets the layer resource key.'''
        ...
    
    @property
    def length(self) -> int:
        '''Gets the layer resource length in bytes.'''
        ...
    
    @property
    def psd_version(self) -> int:
        ...
    
    @classmethod
    @property
    def RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @classmethod
    @property
    def PSB_RESOURCE_SIGNATURE(cls) -> int:
        ...
    
    @property
    def paths(self) -> List[aspose.psd.fileformats.core.vectorpaths.VectorPathRecord]:
        '''Gets the path records.'''
        ...
    
    @paths.setter
    def paths(self, value : List[aspose.psd.fileformats.core.vectorpaths.VectorPathRecord]):
        '''Sets the path records.'''
        ...
    
    @property
    def version(self) -> int:
        '''Gets the version.'''
        ...
    
    @version.setter
    def version(self, value : int):
        '''Sets the version.'''
        ...
    
    @property
    def is_disabled(self) -> bool:
        ...
    
    @is_disabled.setter
    def is_disabled(self, value : bool):
        ...
    
    @property
    def is_not_linked(self) -> bool:
        ...
    
    @is_not_linked.setter
    def is_not_linked(self, value : bool):
        ...
    
    @property
    def is_inverted(self) -> bool:
        ...
    
    @is_inverted.setter
    def is_inverted(self, value : bool):
        ...
    
    @classmethod
    @property
    def TYPE_TOOL_KEY(cls) -> int:
        ...
    
    ...

class LayerLockType:
    '''Layer lock options'''
    
    @classmethod
    @property
    def NONE(cls) -> LayerLockType:
        '''No layer lock'''
        ...
    
    @classmethod
    @property
    def LOCK_TRANSPARENT_PIXELS(cls) -> LayerLockType:
        '''Partially lock a layer  - Confines editing to the opaque portions of the layer.
        This option is equivalent to the Preserve Transparency option in earlier versions of Photoshop.'''
        ...
    
    @classmethod
    @property
    def LOCK_IMAGE_PIXELS(cls) -> LayerLockType:
        '''Partially lock a layer  - Prevents modification of the layer’s pixels using the painting tools.'''
        ...
    
    @classmethod
    @property
    def LOCK_POSITION(cls) -> LayerLockType:
        '''Partially lock a layer  - Prevents the layer’s pixels from being moved.'''
        ...
    
    @classmethod
    @property
    def LOCK_ALL(cls) -> LayerLockType:
        '''Lock all properties of a layer'''
        ...
    
    ...

class LayerSectionSubtype:
    '''The section subtype'''
    
    @classmethod
    @property
    def NOT_USED(cls) -> LayerSectionSubtype:
        '''The not used'''
        ...
    
    @classmethod
    @property
    def NORMAL(cls) -> LayerSectionSubtype:
        '''The normal'''
        ...
    
    @classmethod
    @property
    def SCENE_GROUP(cls) -> LayerSectionSubtype:
        '''The scene group'''
        ...
    
    ...

class LayerSectionType:
    '''The layer section type'''
    
    @classmethod
    @property
    def LAYER(cls) -> LayerSectionType:
        '''The layer.'''
        ...
    
    @classmethod
    @property
    def OPEN_FOLDER(cls) -> LayerSectionType:
        '''The open folder.'''
        ...
    
    @classmethod
    @property
    def CLOSED_FOLDER(cls) -> LayerSectionType:
        '''The closed folder.'''
        ...
    
    @classmethod
    @property
    def SECTION_DIVIDER(cls) -> LayerSectionType:
        '''The section divider.'''
        ...
    
    ...

class LinkDataSourceType:
    '''Defines the LinkDataSourceType enumeration for the data sources in the PSD link resource.'''
    
    @classmethod
    @property
    def NONE(cls) -> LinkDataSourceType:
        '''The empty link resource.'''
        ...
    
    @classmethod
    @property
    def LI_FD(cls) -> LinkDataSourceType:
        '''The embedded linked file data'''
        ...
    
    @classmethod
    @property
    def LI_FE(cls) -> LinkDataSourceType:
        '''The external linked file data'''
        ...
    
    @classmethod
    @property
    def LI_FA(cls) -> LinkDataSourceType:
        '''The linked file alias data'''
        ...
    
    ...

class LnsrResourceType:
    '''Discovered Possible Lnsr Resource Types'''
    
    @classmethod
    @property
    def REND(cls) -> LnsrResourceType:
        '''The rend for text'''
        ...
    
    @classmethod
    @property
    def CONT(cls) -> LnsrResourceType:
        '''The cont for fill layer for example'''
        ...
    
    @classmethod
    @property
    def BGND(cls) -> LnsrResourceType:
        '''The Bgnd for Background layer'''
        ...
    
    @classmethod
    @property
    def LAYR(cls) -> LnsrResourceType:
        '''The layr for regular image layer'''
        ...
    
    @classmethod
    @property
    def UNKNOWN(cls) -> LnsrResourceType:
        '''The Unknown is for situation when we didn't describe enum'''
        ...
    
    ...

class PlacedLayerType:
    '''Defines the PlacedLayerType enumeration for the placed layer PlLd resource.'''
    
    @classmethod
    @property
    def UNKNOWN(cls) -> PlacedLayerType:
        '''The unknown placed layer type'''
        ...
    
    @classmethod
    @property
    def VECTOR(cls) -> PlacedLayerType:
        '''The vector placed layer type'''
        ...
    
    @classmethod
    @property
    def RASTER(cls) -> PlacedLayerType:
        '''The raster placed layer type'''
        ...
    
    @classmethod
    @property
    def IMAGE_STACK(cls) -> PlacedLayerType:
        '''The image stack placed layer type'''
        ...
    
    ...

class SheetColorHighlightEnum:
    '''Possible colors of Sheet color setting.
    It's UI decorative color of layer in layers' list in PS'''
    
    @classmethod
    @property
    def NO_COLOR(cls) -> SheetColorHighlightEnum:
        '''Color is not specified.'''
        ...
    
    @classmethod
    @property
    def RED(cls) -> SheetColorHighlightEnum:
        '''The red color.'''
        ...
    
    @classmethod
    @property
    def ORANGE(cls) -> SheetColorHighlightEnum:
        '''The orange color.'''
        ...
    
    @classmethod
    @property
    def YELLOW(cls) -> SheetColorHighlightEnum:
        '''The yellow color.'''
        ...
    
    @classmethod
    @property
    def GREEN(cls) -> SheetColorHighlightEnum:
        '''The green color.'''
        ...
    
    @classmethod
    @property
    def BLUE(cls) -> SheetColorHighlightEnum:
        '''The blue color.'''
        ...
    
    @classmethod
    @property
    def VIOLET(cls) -> SheetColorHighlightEnum:
        '''The violet color.'''
        ...
    
    @classmethod
    @property
    def GRAY(cls) -> SheetColorHighlightEnum:
        '''The gray color.'''
        ...
    
    ...

